@testsetup module CoreRootfindTesting

include("../../../common/common_rootfind_testing.jl")

end

@testitem "Eisenstadt-Walker Newton-Krylov" setup = [CoreRootfindTesting] tags = [:core] begin
    using LinearAlgebra, Random, LinearSolve
    using BenchmarkTools: @ballocated
    using StaticArrays: @SVector

    @testset for (concrete_jac, linsolve) in (
            (Val(false), KrylovJL_CG(; precs = nothing)),
            (Val(false), KrylovJL_GMRES(; precs = nothing)),
            (
                Val(true),
                KrylovJL_GMRES(;
                    precs = (
                        A,
                        p = nothing,
                    ) -> (
                        Diagonal(randn!(similar(A, size(A, 1)))), LinearAlgebra.I,
                    )
                ),
            ),
        )
        @testset "[OOP] u0: $(typeof(u0))" for u0 in ([1.0, 1.0], @SVector[1.0, 1.0])
            solver = NewtonRaphson(; forcing = EisenstatWalkerForcing2(), linsolve, concrete_jac)
            sol = solve_oop(quadratic_f, u0; solver)
            @test SciMLBase.successful_retcode(sol)
            err = maximum(abs, quadratic_f(sol.u, 2.0))
            @test err < 1.0e-9

            cache = init(
                NonlinearProblem{false}(quadratic_f, u0, 2.0), solver, abstol = 1.0e-9
            )
            @test (@ballocated solve!($cache)) < 200
        end

        @testset "[IIP] u0: $(typeof(u0))" for u0 in ([1.0, 1.0],)
            solver = NewtonRaphson(; forcing = EisenstatWalkerForcing2(), linsolve, concrete_jac)

            sol = solve_iip(quadratic_f!, u0; solver)
            @test SciMLBase.successful_retcode(sol)
            err = maximum(abs, quadratic_f(sol.u, 2.0))
            @test err < 1.0e-9

            cache = init(
                NonlinearProblem{true}(quadratic_f!, u0, 2.0), solver, abstol = 1.0e-9
            )
            @test (@ballocated solve!($cache)) ≤ 64
        end
    end
end

@testitem "NewtonRaphson" setup = [CoreRootfindTesting] tags = [:core] begin
    using ADTypes, LineSearch, LinearAlgebra, Random, LinearSolve
    using LineSearches: LineSearches
    using BenchmarkTools: @ballocated
    using StaticArrays: @SVector
    using Zygote, ForwardDiff, FiniteDiff

    # Conditionally import Enzyme only if not on Julia prerelease
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        using Enzyme
    end

    u0s = ([1.0, 1.0], @SVector[1.0, 1.0], 1.0)

    # Filter autodiff backends based on Julia version
    autodiff_backends = [AutoForwardDiff(), AutoZygote(), AutoFiniteDiff()]
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        push!(autodiff_backends, AutoEnzyme())
    end

    @testset for ad in autodiff_backends
        @testset "$(nameof(typeof(linesearch)))" for linesearch in (
                LineSearchesJL(; method = LineSearches.Static(), autodiff = ad),
                LineSearchesJL(; method = LineSearches.BackTracking(), autodiff = ad),
                LineSearchesJL(; method = LineSearches.MoreThuente(), autodiff = ad),
                LineSearchesJL(; method = LineSearches.StrongWolfe(), autodiff = ad),
                LineSearchesJL(; method = LineSearches.HagerZhang(), autodiff = ad),
                BackTracking(; autodiff = ad),
            )
            @testset "[OOP] u0: $(typeof(u0))" for u0 in u0s
                solver = NewtonRaphson(; linesearch, autodiff = ad)
                sol = solve_oop(quadratic_f, u0; solver)
                @test SciMLBase.successful_retcode(sol)
                err = maximum(abs, quadratic_f(sol.u, 2.0))
                @test err < 1.0e-9

                cache = init(
                    NonlinearProblem{false}(quadratic_f, u0, 2.0), solver, abstol = 1.0e-9
                )
                @test (@ballocated solve!($cache)) < 200
            end

            @testset "[IIP] u0: $(typeof(u0))" for u0 in ([1.0, 1.0],)
                ad isa AutoZygote && continue

                @testset for (concrete_jac, linsolve) in (
                        (Val(false), nothing),
                        (Val(false), KrylovJL_GMRES(; precs = nothing)),
                        (
                            Val(true),
                            KrylovJL_GMRES(;
                                precs = (
                                    A,
                                    p = nothing,
                                ) -> (
                                    Diagonal(randn!(similar(A, size(A, 1)))), LinearAlgebra.I,
                                )
                            ),
                        ),
                        (Val(false), \),
                    )
                    solver = NewtonRaphson(;
                        linsolve, linesearch, autodiff = ad, concrete_jac
                    )

                    sol = solve_iip(quadratic_f!, u0; solver)
                    @test SciMLBase.successful_retcode(sol)
                    err = maximum(abs, quadratic_f(sol.u, 2.0))
                    @test err < 1.0e-9

                    cache = init(
                        NonlinearProblem{true}(quadratic_f!, u0, 2.0), solver, abstol = 1.0e-9
                    )
                    @test (@ballocated solve!($cache)) ≤ 64
                end
            end
        end
    end
end

@testitem "NewtonRaphson: Iterator Interface" setup = [CoreRootfindTesting] tags = [:core] begin
    p = range(0.01, 2, length = 200)
    @test nlprob_iterator_interface(quadratic_f, p, false, NewtonRaphson()) ≈ sqrt.(p)
    @test nlprob_iterator_interface(quadratic_f!, p, true, NewtonRaphson()) ≈ sqrt.(p)
end

@testitem "NewtonRaphson Termination Conditions" setup = [CoreRootfindTesting] tags = [:core] begin
    using StaticArrays: @SVector

    @testset "TC: $(nameof(typeof(termination_condition)))" for termination_condition in
        TERMINATION_CONDITIONS

        @testset "u0: $(typeof(u0))" for u0 in ([1.0, 1.0], 1.0, @SVector([1.0, 1.0]))
            probN = NonlinearProblem(quadratic_f, u0, 2.0)
            sol = solve(probN, NewtonRaphson(); termination_condition)
            err = maximum(abs, quadratic_f(sol.u, 2.0))
            @test err < 1.0e-9
        end
    end
end

@testitem "PseudoTransient" setup = [CoreRootfindTesting] tags = [:core] begin
    using ADTypes, Random, LinearSolve, LinearAlgebra
    using BenchmarkTools: @ballocated
    using StaticArrays: @SVector
    using Zygote, ForwardDiff, FiniteDiff

    # Conditionally import Enzyme only if not on Julia prerelease
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        using Enzyme
    end

    preconditioners = [
        (u0) -> nothing,
        u0 -> ((args...) -> (Diagonal(rand!(similar(u0))), nothing)),
    ]

    # Filter autodiff backends based on Julia version
    autodiff_backends = [AutoForwardDiff(), AutoZygote(), AutoFiniteDiff()]
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        push!(autodiff_backends, AutoEnzyme())
    end

    @testset for ad in autodiff_backends
        u0s = ([1.0, 1.0], @SVector[1.0, 1.0], 1.0)

        @testset "[OOP] u0: $(typeof(u0))" for u0 in u0s
            solver = PseudoTransient(; alpha_initial = 10.0, autodiff = ad)
            sol = solve_oop(quadratic_f, u0; solver)
            @test SciMLBase.successful_retcode(sol)
            err = maximum(abs, quadratic_f(sol.u, 2.0))
            @test err < 1.0e-9

            cache = init(
                NonlinearProblem{false}(quadratic_f, u0, 2.0), solver, abstol = 1.0e-9
            )
            @test (@ballocated solve!($cache)) < 200
        end

        @testset "[IIP] u0: $(typeof(u0))" for u0 in ([1.0, 1.0],)
            ad isa AutoZygote && continue

            @testset for (concrete_jac, linsolve) in (
                    (Val(false), nothing),
                    (Val(false), KrylovJL_GMRES(; precs = nothing)),
                    (
                        Val(true),
                        KrylovJL_GMRES(;
                            precs = (
                                A,
                                p = nothing,
                            ) -> (
                                Diagonal(randn!(similar(A, size(A, 1)))), LinearAlgebra.I,
                            )
                        ),
                    ),
                    (Val(false), \),
                )
                solver = PseudoTransient(;
                    alpha_initial = 10.0, linsolve, autodiff = ad, concrete_jac
                )
                sol = solve_iip(quadratic_f!, u0; solver)
                @test SciMLBase.successful_retcode(sol)
                err = maximum(abs, quadratic_f(sol.u, 2.0))
                @test err < 1.0e-9

                cache = init(
                    NonlinearProblem{true}(quadratic_f!, u0, 2.0), solver, abstol = 1.0e-9
                )
                @test (@ballocated solve!($cache)) ≤ 64
            end
        end
    end
end

@testitem "PseudoTransient: Iterator Interface" setup = [CoreRootfindTesting] tags = [:core] begin
    p = range(0.01, 2, length = 200)
    @test nlprob_iterator_interface(
        quadratic_f, p, false, PseudoTransient(; alpha_initial = 10.0)
    ) ≈ sqrt.(p)
    @test nlprob_iterator_interface(
        quadratic_f!, p, true, PseudoTransient(; alpha_initial = 10.0)
    ) ≈ sqrt.(p)
end

@testitem "PseudoTransient Termination Conditions" setup = [CoreRootfindTesting] tags = [:core] begin
    using StaticArrays: @SVector

    @testset "TC: $(nameof(typeof(termination_condition)))" for termination_condition in
        TERMINATION_CONDITIONS

        @testset "u0: $(typeof(u0))" for u0 in ([1.0, 1.0], 1.0, @SVector([1.0, 1.0]))
            probN = NonlinearProblem(quadratic_f, u0, 2.0)
            sol = solve(probN, PseudoTransient(); termination_condition)
            err = maximum(abs, quadratic_f(sol.u, 2.0))
            @test err < 1.0e-9
        end
    end
end

@testitem "TrustRegion" setup = [CoreRootfindTesting] tags = [:core] begin
    using ADTypes, LinearSolve, LinearAlgebra
    using BenchmarkTools: @ballocated
    using StaticArrays: @SVector
    using Zygote, ForwardDiff, FiniteDiff

    # Conditionally import Enzyme only if not on Julia prerelease
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        using Enzyme
    end

    radius_update_schemes = [
        RadiusUpdateSchemes.Simple, RadiusUpdateSchemes.NocedalWright,
        RadiusUpdateSchemes.NLsolve, RadiusUpdateSchemes.Hei,
        RadiusUpdateSchemes.Yuan, RadiusUpdateSchemes.Fan, RadiusUpdateSchemes.Bastin,
    ]

    # Filter autodiff backends based on Julia version
    autodiff_backends = [AutoForwardDiff(), AutoZygote(), AutoFiniteDiff()]
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        push!(autodiff_backends, AutoEnzyme())
    end

    @testset for ad in autodiff_backends
        @testset for radius_update_scheme in radius_update_schemes,
                linsolve in (nothing, LUFactorization(), KrylovJL_GMRES(), \)

            @testset "[OOP] u0: $(typeof(u0))" for u0 in (
                    [1.0, 1.0], 1.0, @SVector[1.0, 1.0], 1.0,
                )
                abstol = ifelse(linsolve isa KrylovJL, 1.0e-6, 1.0e-9)
                solver = TrustRegion(; radius_update_scheme, linsolve)
                sol = solve_oop(quadratic_f, u0; solver, abstol)
                @test SciMLBase.successful_retcode(sol)
                err = maximum(abs, quadratic_f(sol.u, 2.0))
                @test err < abstol

                cache = init(NonlinearProblem{false}(quadratic_f, u0, 2.0), solver, abstol)
                @test (@ballocated solve!($cache)) < 200
            end

            @testset "[IIP] u0: $(typeof(u0))" for u0 in ([1.0, 1.0],)
                ad isa AutoZygote && continue

                abstol = ifelse(linsolve isa KrylovJL, 1.0e-6, 1.0e-9)
                solver = TrustRegion(; radius_update_scheme, linsolve)
                sol = solve_iip(quadratic_f!, u0; solver, abstol)
                @test SciMLBase.successful_retcode(sol)
                err = maximum(abs, quadratic_f(sol.u, 2.0))
                @test err < abstol

                cache = init(NonlinearProblem{true}(quadratic_f!, u0, 2.0), solver, abstol)
                @test (@ballocated solve!($cache)) ≤ 64
            end
        end
    end
end

@testitem "TrustRegion: Iterator Interface" setup = [CoreRootfindTesting] tags = [:core] begin
    p = range(0.01, 2, length = 200)
    @test nlprob_iterator_interface(quadratic_f, p, false, TrustRegion()) ≈ sqrt.(p)
    @test nlprob_iterator_interface(quadratic_f!, p, true, TrustRegion()) ≈ sqrt.(p)
end

@testitem "TrustRegion NewtonRaphson Fails" setup = [CoreRootfindTesting] tags = [:core] begin
    u0 = [-10.0, -1.0, 1.0, 2.0, 3.0, 4.0, 10.0]
    p = [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    sol = solve_oop(newton_fails, u0, p; solver = TrustRegion())
    @test SciMLBase.successful_retcode(sol)
    @test all(abs.(newton_fails(sol.u, p)) .< 1.0e-9)
end

@testitem "TrustRegion: Kwargs" setup = [CoreRootfindTesting] tags = [:core] begin
    max_trust_radius = [10.0, 100.0, 1000.0]
    initial_trust_radius = [10.0, 1.0, 0.1]
    step_threshold = [0.0, 0.01, 0.25]
    shrink_threshold = [0.25, 0.3, 0.5]
    expand_threshold = [0.5, 0.8, 0.9]
    shrink_factor = [0.1, 0.3, 0.5]
    expand_factor = [1.5, 2.0, 3.0]
    max_shrink_times = [10, 20, 30]

    list_of_options = zip(
        max_trust_radius, initial_trust_radius, step_threshold, shrink_threshold,
        expand_threshold, shrink_factor, expand_factor, max_shrink_times
    )

    for options in list_of_options
        alg = TrustRegion(;
            max_trust_radius = options[1], initial_trust_radius = options[2],
            step_threshold = options[3], shrink_threshold = options[4],
            expand_threshold = options[5], shrink_factor = options[6],
            expand_factor = options[7], max_shrink_times = options[8]
        )

        sol = solve_oop(quadratic_f, [1.0, 1.0], 2.0; solver = alg)
        @test SciMLBase.successful_retcode(sol)
        err = maximum(abs, quadratic_f(sol.u, 2.0))
        @test err < 1.0e-9
    end
end

@testitem "TrustRegion OOP / IIP Consistency" setup = [CoreRootfindTesting] tags = [:core] begin
    maxiterations = [2, 3, 4, 5]
    u0 = [1.0, 1.0]
    @testset for radius_update_scheme in [
            RadiusUpdateSchemes.Simple, RadiusUpdateSchemes.NocedalWright,
            RadiusUpdateSchemes.NLsolve, RadiusUpdateSchemes.Hei,
            RadiusUpdateSchemes.Yuan, RadiusUpdateSchemes.Fan, RadiusUpdateSchemes.Bastin,
        ]
        @testset for maxiters in maxiterations
            solver = TrustRegion(; radius_update_scheme)
            sol_iip = solve_iip(quadratic_f!, u0; solver, maxiters)
            sol_oop = solve_oop(quadratic_f, u0; solver, maxiters)
            @test sol_iip.u ≈ sol_oop.u
        end
    end
end

@testitem "TrustRegion Termination Conditions" setup = [CoreRootfindTesting] tags = [:core] begin
    using StaticArrays: @SVector

    @testset "TC: $(nameof(typeof(termination_condition)))" for termination_condition in
        TERMINATION_CONDITIONS

        @testset "u0: $(typeof(u0))" for u0 in ([1.0, 1.0], 1.0, @SVector([1.0, 1.0]))
            probN = NonlinearProblem(quadratic_f, u0, 2.0)
            sol = solve(probN, TrustRegion(); termination_condition)
            err = maximum(abs, quadratic_f(sol.u, 2.0))
            @test err < 1.0e-9
        end
    end
end

@testitem "LevenbergMarquardt" setup = [CoreRootfindTesting] tags = [:core] begin
    using ADTypes, LinearSolve, LinearAlgebra
    using BenchmarkTools: @ballocated
    using StaticArrays: SVector, @SVector
    using Zygote, ForwardDiff, FiniteDiff

    # Conditionally import Enzyme only if not on Julia prerelease
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        using Enzyme
    end

    # Filter autodiff backends based on Julia version
    autodiff_backends = [AutoForwardDiff(), AutoZygote(), AutoFiniteDiff()]
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        push!(autodiff_backends, AutoEnzyme())
    end

    @testset for ad in autodiff_backends
        solver = LevenbergMarquardt(; autodiff = ad)

        @testset "[OOP] u0: $(typeof(u0))" for u0 in ([1.0, 1.0], 1.0, @SVector([1.0, 1.0]))
            if ad isa ADTypes.AutoZygote && u0 isa SVector
                # Zygote converts SVector to a Matrix that triggers a bug upstream
                @test_broken solve_oop(quadratic_f, u0; solver)
                continue
            end

            sol = solve_oop(quadratic_f, u0; solver)
            @test SciMLBase.successful_retcode(sol)
            err = maximum(abs, quadratic_f(sol.u, 2.0))
            @test err < 1.0e-9

            cache = init(
                NonlinearProblem{false}(quadratic_f, u0, 2.0),
                LevenbergMarquardt(), abstol = 1.0e-9
            )
            @test (@ballocated solve!($cache)) < 200
        end

        @testset "[IIP] u0: $(typeof(u0))" for u0 in ([1.0, 1.0],)
            ad isa AutoZygote && continue

            sol = solve_iip(quadratic_f!, u0; solver)
            @test SciMLBase.successful_retcode(sol)
            err = maximum(abs, quadratic_f(sol.u, 2.0))
            @test err < 1.0e-9

            cache = init(
                NonlinearProblem{true}(quadratic_f!, u0, 2.0),
                LevenbergMarquardt(), abstol = 1.0e-9
            )
            @test (@ballocated solve!($cache)) ≤ 64
        end
    end
end

@testitem "LevenbergMarquardt NewtonRaphson Fails" setup = [CoreRootfindTesting] tags = [:core] begin
    u0 = [-10.0, -1.0, 1.0, 2.0, 3.0, 4.0, 10.0]
    p = [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
    sol = solve_oop(newton_fails, u0, p; solver = LevenbergMarquardt())
    @test SciMLBase.successful_retcode(sol)
    @test all(abs.(newton_fails(sol.u, p)) .< 1.0e-9)
end

@testitem "LevenbergMarquardt: Iterator Interface" setup = [CoreRootfindTesting] tags = [:core] begin
    p = range(0.01, 2, length = 200)
    @test nlprob_iterator_interface(quadratic_f, p, false, LevenbergMarquardt()) ≈ sqrt.(p)
    @test nlprob_iterator_interface(quadratic_f!, p, true, LevenbergMarquardt()) ≈ sqrt.(p)
end

@testitem "LevenbergMarquardt Termination Conditions" setup = [CoreRootfindTesting] tags = [:core] begin
    using StaticArrays: @SVector

    @testset "TC: $(nameof(typeof(termination_condition)))" for termination_condition in
        TERMINATION_CONDITIONS

        @testset "u0: $(typeof(u0))" for u0 in ([1.0, 1.0], 1.0, @SVector([1.0, 1.0]))
            probN = NonlinearProblem(quadratic_f, u0, 2.0)
            sol = solve(probN, LevenbergMarquardt(); termination_condition)
            err = maximum(abs, quadratic_f(sol.u, 2.0))
            @test err < 1.0e-9
        end
    end
end

@testitem "LevenbergMarquardt: Kwargs" setup = [CoreRootfindTesting] tags = [:core] begin
    damping_initial = [0.5, 2.0, 5.0]
    damping_increase_factor = [1.5, 3.0, 10.0]
    damping_decrease_factor = Float64[2, 5, 10.0]
    finite_diff_step_geodesic = [0.02, 0.2, 0.3]
    α_geodesic = [0.6, 0.8, 0.9]
    b_uphill = Float64[0, 1, 2]
    min_damping_D = [1.0e-12, 1.0e-9, 1.0e-4]

    list_of_options = zip(
        damping_initial, damping_increase_factor, damping_decrease_factor,
        finite_diff_step_geodesic, α_geodesic, b_uphill, min_damping_D
    )
    for options in list_of_options
        alg = LevenbergMarquardt(;
            damping_initial = options[1], damping_increase_factor = options[2],
            damping_decrease_factor = options[3],
            finite_diff_step_geodesic = options[4], α_geodesic = options[5],
            b_uphill = options[6], min_damping_D = options[7]
        )

        sol = solve_oop(quadratic_f, [1.0, 1.0], 2.0; solver = alg, maxiters = 10000)
        @test SciMLBase.successful_retcode(sol)
        err = maximum(abs, quadratic_f(sol.u, 2.0))
        @test err < 1.0e-9
    end
end

@testitem "Simple Sparse AutoDiff" setup = [CoreRootfindTesting] tags = [:core] begin
    using ADTypes, SparseConnectivityTracer, SparseMatrixColorings

    # Filter autodiff backends based on Julia version
    autodiff_backends = [AutoForwardDiff(), AutoFiniteDiff(), AutoZygote()]
    if isempty(VERSION.prerelease) && VERSION < v"1.12"
        push!(autodiff_backends, AutoEnzyme())
    end

    @testset for ad in autodiff_backends
        @testset for u0 in ([1.0, 1.0], 1.0)
            prob = NonlinearProblem(
                NonlinearFunction(quadratic_f; sparsity = TracerSparsityDetector()), u0, 2.0
            )

            @testset "Newton Raphson" begin
                sol = solve(prob, NewtonRaphson(; autodiff = ad))
                err = maximum(abs, quadratic_f(sol.u, 2.0))
                @test err < 1.0e-9
            end

            @testset "Trust Region" begin
                sol = solve(prob, TrustRegion(; autodiff = ad))
                err = maximum(abs, quadratic_f(sol.u, 2.0))
                @test err < 1.0e-9
            end
        end
    end
end

@testitem "Custom JVP" setup = [CoreRootfindTesting] tags = [:core] begin
    using LinearAlgebra, LinearSolve, ADTypes

    function F(u::Vector{Float64}, p::Vector{Float64})
        Δ = Tridiagonal(-ones(99), 2 * ones(100), -ones(99))
        return u + 0.1 * u .* Δ * u - p
    end

    function F!(du::Vector{Float64}, u::Vector{Float64}, p::Vector{Float64})
        Δ = Tridiagonal(-ones(99), 2 * ones(100), -ones(99))
        du .= u + 0.1 * u .* Δ * u - p
        return nothing
    end

    function JVP(v::Vector{Float64}, u::Vector{Float64}, p::Vector{Float64})
        Δ = Tridiagonal(-ones(99), 2 * ones(100), -ones(99))
        return v + 0.1 * (u .* Δ * v + v .* Δ * u)
    end

    function JVP!(
            du::Vector{Float64}, v::Vector{Float64}, u::Vector{Float64}, p::Vector{Float64}
        )
        Δ = Tridiagonal(-ones(99), 2 * ones(100), -ones(99))
        du .= v + 0.1 * (u .* Δ * v + v .* Δ * u)
        return nothing
    end

    u0 = rand(100)

    prob = NonlinearProblem(NonlinearFunction{false}(F; jvp = JVP), u0, u0)
    sol = solve(prob, NewtonRaphson(; linsolve = KrylovJL_GMRES()); abstol = 1.0e-13)
    err = maximum(abs, sol.resid)
    @test err < 1.0e-6

    sol = solve(
        prob, TrustRegion(; linsolve = KrylovJL_GMRES(), vjp_autodiff = AutoFiniteDiff());
        abstol = 1.0e-13
    )
    err = maximum(abs, sol.resid)
    @test err < 1.0e-6

    prob = NonlinearProblem(NonlinearFunction{true}(F!; jvp = JVP!), u0, u0)
    sol = solve(prob, NewtonRaphson(; linsolve = KrylovJL_GMRES()); abstol = 1.0e-13)
    err = maximum(abs, sol.resid)
    @test err < 1.0e-6

    sol = solve(
        prob, TrustRegion(; linsolve = KrylovJL_GMRES(), vjp_autodiff = AutoFiniteDiff());
        abstol = 1.0e-13
    )
    err = maximum(abs, sol.resid)
    @test err < 1.0e-6
end

@testsetup module CoreNLLSTesting

using NonlinearSolveFirstOrder, LineSearch, ADTypes, LinearSolve
using LineSearches: LineSearches
using ForwardDiff, FiniteDiff, Zygote

include("../../../common/common_nlls_testing.jl")

linesearches = []
for lsmethod in [
        LineSearches.Static(), LineSearches.HagerZhang(), LineSearches.MoreThuente(),
        LineSearches.StrongWolfe(), LineSearches.BackTracking(),
    ]
    push!(linesearches, LineSearchesJL(; method = lsmethod))
end
push!(linesearches, BackTracking())

solvers = []
for linsolve in [nothing, LUFactorization(), KrylovJL_GMRES(), KrylovJL_LSMR()]
    vjp_autodiffs = linsolve isa KrylovJL ? [nothing, AutoZygote(), AutoFiniteDiff()] :
        [nothing]
    for linesearch in linesearches, vjp_autodiff in vjp_autodiffs

        push!(solvers, GaussNewton(; linsolve, linesearch, vjp_autodiff))
    end
end
append!(
    solvers,
    [
        LevenbergMarquardt(),
        LevenbergMarquardt(; linsolve = LUFactorization()),
        LevenbergMarquardt(; linsolve = KrylovJL_GMRES()),
        LevenbergMarquardt(; linsolve = KrylovJL_LSMR()),
    ]
)
for radius_update_scheme in [
        RadiusUpdateSchemes.Simple, RadiusUpdateSchemes.NocedalWright,
        RadiusUpdateSchemes.NLsolve, RadiusUpdateSchemes.Hei,
        RadiusUpdateSchemes.Yuan, RadiusUpdateSchemes.Fan, RadiusUpdateSchemes.Bastin,
    ]
    push!(solvers, TrustRegion(; radius_update_scheme))
end

export solvers

end

@testitem "General NLLS Solvers" setup = [CoreNLLSTesting] tags = [:core] begin
    using LinearAlgebra

    nlls_problems = [prob_oop, prob_iip, prob_oop_vjp, prob_iip_vjp]

    for prob in nlls_problems, solver in solvers

        sol = solve(prob, solver; maxiters = 10000, abstol = 1.0e-6)
        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, 2) < 1.0e-6
    end
end

@testitem "Overdetermined NLLS with StaticArrays" tags = [:core] begin
    using NonlinearSolveFirstOrder, LinearAlgebra, StaticArrays

    # Overdetermined: 4 residuals, 2 unknowns (issue #560)
    function f_static(u, p)
        x, y = u
        return SA[
            sin(x) + y^2 - 1.0,
            x^2 + y - 2.0,
            exp(x) + x * y - 3.0,
            x + y - 1.0,
        ]
    end
    f_vec(u, p) = collect(f_static(u, p))

    prob_static = NonlinearLeastSquaresProblem(NonlinearFunction(f_static), SA[0.0, 0.0])
    prob_vec = NonlinearLeastSquaresProblem(NonlinearFunction(f_vec), [0.0, 0.0])

    for solver in (GaussNewton(), LevenbergMarquardt(), TrustRegion())
        sol_static = solve(prob_static, solver; maxiters = 10000, abstol = 1.0e-6)
        sol_vec = solve(prob_vec, solver; maxiters = 10000, abstol = 1.0e-6)
        @test SciMLBase.successful_retcode(sol_static)

        # We don't test the residuals themselves because they're quite large for
        # an overdetermined system. Instead we just check the results between
        # Vector/StaticArray match.
        @test norm(collect(sol_static.u) - sol_vec.u) < 1.0e-6
    end
end

"""
    GeneralizedFirstOrderAlgorithm(;
        descent, linesearch = missing,
        trustregion = missing, autodiff = nothing, vjp_autodiff = nothing,
        jvp_autodiff = nothing, max_shrink_times::Int = typemax(Int),
        concrete_jac = Val(false), name::Symbol = :unknown
    )

This is a Generalization of First-Order (uses Jacobian) Nonlinear Solve Algorithms. The most
common example of this is Newton-Raphson Method.

First Order here refers to the order of differentiation, and should not be confused with the
order of convergence.

### Keyword Arguments

  - `trustregion`: Globalization using a Trust Region Method. This needs to follow the
    [`NonlinearSolveBase.AbstractTrustRegionMethod`](@ref) interface.
  - `descent`: The descent method to use to compute the step. This needs to follow the
    [`NonlinearSolveBase.AbstractDescentDirection`](@ref) interface.
  - `max_shrink_times`: The maximum number of times the trust region radius can be shrunk
    before the algorithm terminates.
"""
@concrete struct GeneralizedFirstOrderAlgorithm <: AbstractNonlinearSolveAlgorithm
    linesearch
    trustregion
    descent
    forcing
    max_shrink_times::Int

    autodiff
    vjp_autodiff
    jvp_autodiff

    concrete_jac <: Union{Val{false}, Val{true}}
    name::Symbol
end

function GeneralizedFirstOrderAlgorithm(;
        descent, linesearch = missing, trustregion = missing, autodiff = nothing,
        vjp_autodiff = nothing, jvp_autodiff = nothing, max_shrink_times::Int = typemax(Int),
        concrete_jac = Val(false), forcing = nothing, name::Symbol = :unknown
    )
    concrete_jac = concrete_jac isa Bool ? Val(concrete_jac) :
        (concrete_jac isa Val ? concrete_jac : Val(concrete_jac !== nothing))
    return GeneralizedFirstOrderAlgorithm(
        linesearch, trustregion, descent, forcing, max_shrink_times,
        autodiff, vjp_autodiff, jvp_autodiff,
        concrete_jac, name
    )
end

@concrete mutable struct GeneralizedFirstOrderAlgorithmCache <: AbstractNonlinearSolveCache
    # Basic Requirements
    fu
    u
    u_cache
    p
    alg <: GeneralizedFirstOrderAlgorithm
    prob <: AbstractNonlinearProblem
    globalization <: Union{Val{:LineSearch}, Val{:TrustRegion}, Val{:None}}

    # Internal Caches
    jac_cache
    descent_cache
    forcing_cache
    linesearch_cache
    trustregion_cache

    # Counters
    stats::NLStats
    nsteps::Int
    maxiters::Int
    maxtime
    max_shrink_times::Int

    # Timer
    timer
    total_time::Float64

    # State Affect
    make_new_jacobian::Bool

    # Termination & Tracking
    termination_cache
    trace
    retcode::ReturnCode.T
    force_stop::Bool
    kwargs

    initializealg

    verbose
end

function SciMLBase.get_du(cache::GeneralizedFirstOrderAlgorithmCache)
    return SciMLBase.get_du(cache.descent_cache)
end
function NonlinearSolveBase.set_du!(cache::GeneralizedFirstOrderAlgorithmCache, δu)
    return NonlinearSolveBase.set_du!(cache.descent_cache, δu)
end

function InternalAPI.reinit_self!(
        cache::GeneralizedFirstOrderAlgorithmCache, args...; p = cache.p, u0 = cache.u,
        alias_u0::Bool = hasproperty(cache, :alias_u0) ? cache.alias_u0 : false,
        maxiters = hasproperty(cache, :maxiters) ? cache.maxiters : 1000,
        maxtime = hasproperty(cache, :maxtime) ? cache.maxtime : nothing, kwargs...
    )
    Utils.reinit_common!(cache, u0, p, alias_u0)

    InternalAPI.reinit!(cache.stats)
    cache.nsteps = 0
    cache.maxiters = maxiters
    cache.maxtime = maxtime
    cache.total_time = 0.0
    cache.force_stop = false
    cache.retcode = ReturnCode.Default
    cache.make_new_jacobian = true

    NonlinearSolveBase.reset!(cache.trace)
    SciMLBase.reinit!(
        cache.termination_cache, NonlinearSolveBase.get_fu(cache),
        NonlinearSolveBase.get_u(cache); kwargs...
    )
    NonlinearSolveBase.reset_timer!(cache.timer)
    return
end

NonlinearSolveBase.@internal_caches(
    GeneralizedFirstOrderAlgorithmCache,
    :jac_cache, :descent_cache, :linesearch_cache, :trustregion_cache, :forcing_cache
)

function SciMLBase.__init(
        prob::AbstractNonlinearProblem, alg::GeneralizedFirstOrderAlgorithm, args...;
        stats = NLStats(0, 0, 0, 0, 0), alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = false), maxiters = 1000,
        abstol = nothing, reltol = nothing, maxtime = nothing,
        termination_condition = nothing, internalnorm::IN = L2_NORM, verbose = NonlinearVerbosity(),
        linsolve_kwargs = (;), initializealg = NonlinearSolveBase.NonlinearSolveDefaultInit(), kwargs...
    ) where {IN}
    if haskey(kwargs, :alias_u0)
        alias = SciMLBase.NonlinearAliasSpecifier(alias_u0 = kwargs[:alias_u0])
    end
    alias_u0 = alias.alias_u0
    @set! alg.autodiff = NonlinearSolveBase.select_jacobian_autodiff(prob, alg.autodiff)
    provided_jvp_autodiff = alg.jvp_autodiff !== nothing
    @set! alg.jvp_autodiff = if !provided_jvp_autodiff && alg.autodiff !== nothing &&
            (
            ADTypes.mode(alg.autodiff) isa ADTypes.ForwardMode ||
                ADTypes.mode(alg.autodiff) isa
                ADTypes.ForwardOrReverseMode
        )
        NonlinearSolveBase.select_forward_mode_autodiff(prob, alg.autodiff)
    else
        NonlinearSolveBase.select_forward_mode_autodiff(prob, alg.jvp_autodiff)
    end
    provided_vjp_autodiff = alg.vjp_autodiff !== nothing
    @set! alg.vjp_autodiff = if !provided_vjp_autodiff && alg.autodiff !== nothing &&
            (
            ADTypes.mode(alg.autodiff) isa ADTypes.ReverseMode ||
                ADTypes.mode(alg.autodiff) isa
                ADTypes.ForwardOrReverseMode
        )
        NonlinearSolveBase.select_reverse_mode_autodiff(prob, alg.autodiff)
    else
        NonlinearSolveBase.select_reverse_mode_autodiff(prob, alg.vjp_autodiff)
    end

    if verbose isa Bool
        if verbose
            verbose = NonlinearVerbosity()
        else
            verbose = NonlinearVerbosity(None())
        end
    elseif verbose isa AbstractVerbosityPreset
        verbose = NonlinearVerbosity(verbose)
    end

    # Enzyme cannot differentiate through FunctionWrappers' llvmcall.
    # Create unwrapped prob for all AD-related constructions when using Enzyme.
    _ad_prob = NonlinearSolveBase.maybe_unwrap_prob_for_enzyme(
        prob, alg.autodiff, alg.jvp_autodiff, alg.vjp_autodiff
    )

    timer = get_timer_output()
    @static_timeit timer "cache construction" begin
        u = Utils.maybe_unaliased(prob.u0, alias_u0)
        fu = Utils.evaluate_f(prob, u)
        @bb u_cache = copy(u)

        linsolve = NonlinearSolveBase.get_linear_solver(alg.descent)

        abstol, reltol,
            termination_cache = NonlinearSolveBase.init_termination_cache(
            prob, abstol, reltol, fu, u, termination_condition, Val(:regular)
        )
        linsolve_kwargs = merge((; verbose = verbose.linear_verbosity, abstol, reltol), linsolve_kwargs)

        jac_cache = NonlinearSolveBase.construct_jacobian_cache(
            _ad_prob, alg, _ad_prob.f, fu, u, _ad_prob.p;
            stats, alg.autodiff, linsolve, alg.jvp_autodiff, alg.vjp_autodiff
        )
        J = reused_jacobian(jac_cache, u)

        descent_cache = InternalAPI.init(
            prob, alg.descent, J, fu, u; stats, abstol, reltol, internalnorm,
            linsolve_kwargs, timer
        )
        du = SciMLBase.get_du(descent_cache)

        has_linesearch = alg.linesearch !== missing && alg.linesearch !== nothing
        has_trustregion = alg.trustregion !== missing && alg.trustregion !== nothing
        has_forcing = alg.forcing !== missing && alg.forcing !== nothing && !(u isa Number) && !(J isa Diagonal)

        if has_trustregion && has_linesearch
            error("TrustRegion and LineSearch methods are algorithmically incompatible.")
        end

        globalization = Val(:None)
        linesearch_cache = nothing
        trustregion_cache = nothing
        forcing_cache = nothing

        if has_trustregion
            NonlinearSolveBase.supports_trust_region(alg.descent) ||
                error("Trust Region not supported by $(alg.descent).")
            # Standardize AD tags so VecJac/JacVec operators use NonlinearSolveTag
            # when the function is wrapped by AutoSpecialize.
            _tr_vjp_ad = NonlinearSolveBase.standardize_forwarddiff_tag(
                alg.vjp_autodiff, _ad_prob
            )
            _tr_jvp_ad = NonlinearSolveBase.standardize_forwarddiff_tag(
                alg.jvp_autodiff, _ad_prob
            )
            trustregion_cache = InternalAPI.init(
                _ad_prob, alg.trustregion, _ad_prob.f, fu, u, _ad_prob.p;
                vjp_autodiff = _tr_vjp_ad, jvp_autodiff = _tr_jvp_ad,
                stats, internalnorm, kwargs...
            )
            globalization = Val(:TrustRegion)
        end

        if has_linesearch
            NonlinearSolveBase.supports_line_search(alg.descent) ||
                error("Line Search not supported by $(alg.descent).")
            _ls_ad = NonlinearSolveBase.standardize_forwarddiff_tag(
                ifelse(provided_jvp_autodiff, alg.jvp_autodiff, alg.vjp_autodiff),
                _ad_prob
            )
            linesearch_cache = CommonSolve.init(
                _ad_prob, alg.linesearch, fu, u; stats, internalnorm,
                autodiff = _ls_ad, kwargs...
            )
            globalization = Val(:LineSearch)
        end

        if has_forcing
            forcing_cache = InternalAPI.init(
                _ad_prob, alg.forcing, fu, u, u, _ad_prob.p; stats, internalnorm,
                autodiff = ifelse(
                    provided_jvp_autodiff, alg.jvp_autodiff, alg.vjp_autodiff
                ),
                verbose,
                kwargs...
            )
        end

        trace = NonlinearSolveBase.init_nonlinearsolve_trace(
            prob, alg, u, fu, J, du; kwargs...
        )

        cache = GeneralizedFirstOrderAlgorithmCache(
            fu, u, u_cache, prob.p, alg, prob, globalization,
            jac_cache, descent_cache, forcing_cache, linesearch_cache, trustregion_cache,
            stats, 0, maxiters, maxtime, alg.max_shrink_times, timer,
            0.0, true, termination_cache, trace, ReturnCode.Default, false, kwargs,
            initializealg, verbose
        )
        NonlinearSolveBase.run_initialization!(cache)
    end

    return cache
end

function InternalAPI.step!(
        cache::GeneralizedFirstOrderAlgorithmCache;
        recompute_jacobian::Union{Nothing, Bool} = nothing
    )
    @static_timeit cache.timer "jacobian" begin
        if (recompute_jacobian === nothing || recompute_jacobian) && cache.make_new_jacobian
            J = cache.jac_cache(cache.u)
            new_jacobian = true
        else
            J = reused_jacobian(cache.jac_cache, cache.u)
            new_jacobian = false
        end
    end

    has_forcing = cache.forcing_cache !== nothing && cache.forcing_cache !== missing && !(cache.u isa Number) && !(J isa Diagonal)

    if has_forcing
        pre_step_forcing!(cache.forcing_cache, cache.descent_cache, J, cache.u, cache.fu, cache.nsteps)
    end

    @static_timeit cache.timer "descent" begin
        if cache.trustregion_cache !== nothing &&
                hasfield(typeof(cache.trustregion_cache), :trust_region)
            descent_result = InternalAPI.solve!(
                cache.descent_cache, J, cache.fu, cache.u;
                new_jacobian, cache.trustregion_cache.trust_region, cache.kwargs...
            )
        else
            descent_result = InternalAPI.solve!(
                cache.descent_cache, J, cache.fu, cache.u; new_jacobian, cache.kwargs...
            )
        end
    end

    if !descent_result.linsolve_success
        if new_jacobian
            # Jacobian Information is current and linear solve failed terminate the solve
            cache.retcode = ReturnCode.InternalLinearSolveFailed
            cache.force_stop = true
            return
        else
            # Jacobian Information is not current and linear solve failed, recompute it
            @SciMLMessage("Linear Solve Failed but Jacobian information is not current. Retrying with updated Jacobian. \
                Retrying with updated Jacobian.", cache.verbose, :linsolve_failed_noncurrent)
            # In the 2nd call the `new_jacobian` is guaranteed to be `true`.
            cache.make_new_jacobian = true
            InternalAPI.step!(cache; recompute_jacobian = true, cache.kwargs...)
            return
        end
    end

    δu, descent_intermediates = descent_result.δu, descent_result.extras

    if descent_result.success
        if has_forcing
            post_step_forcing!(cache.forcing_cache, J, cache.u, cache.fu, δu, cache.nsteps)
        end

        cache.make_new_jacobian = true
        if cache.globalization isa Val{:LineSearch}
            @static_timeit cache.timer "linesearch" begin
                linesearch_sol = CommonSolve.solve!(cache.linesearch_cache, cache.u, δu)
                linesearch_failed = !SciMLBase.successful_retcode(linesearch_sol.retcode)
                α = linesearch_sol.step_size
            end
            if linesearch_failed
                cache.retcode = ReturnCode.InternalLineSearchFailed
                cache.force_stop = true
            end
            @static_timeit cache.timer "step" begin
                @bb axpy!(α, δu, cache.u)
                Utils.evaluate_f!(cache, cache.u, cache.p)
            end
        elseif cache.globalization isa Val{:TrustRegion}
            @static_timeit cache.timer "trustregion" begin
                tr_accepted, u_new,
                    fu_new = InternalAPI.solve!(
                    cache.trustregion_cache, J, cache.fu, cache.u, δu, descent_intermediates
                )
                if tr_accepted
                    @bb copyto!(cache.u, u_new)
                    @bb copyto!(cache.fu, fu_new)
                    α = true
                else
                    α = false
                    cache.make_new_jacobian = false
                end
                if hasfield(typeof(cache.trustregion_cache), :shrink_counter) &&
                        cache.trustregion_cache.shrink_counter > cache.max_shrink_times
                    cache.retcode = ReturnCode.ShrinkThresholdExceeded
                    cache.force_stop = true
                end
            end
        elseif cache.globalization isa Val{:None}
            @static_timeit cache.timer "step" begin
                @bb axpy!(1, δu, cache.u)
                Utils.evaluate_f!(cache, cache.u, cache.p)
            end
            α = true
        else
            error("Unknown Globalization Strategy: $(cache.globalization). Allowed values \
                   are (:LineSearch, :TrustRegion, :None)")
        end
        NonlinearSolveBase.check_and_update!(cache, cache.fu, cache.u, cache.u_cache)
    else
        α = false
        cache.make_new_jacobian = false
    end

    update_trace!(cache, α)
    @bb copyto!(cache.u_cache, cache.u)

    NonlinearSolveBase.callback_into_cache!(cache)

    return nothing
end

function SciMLBase.__init(prob::NonlinearLeastSquaresProblem, ::Nothing, args...; kwargs...)
    return SciMLBase.__init(
        prob, FastShortcutNLLSPolyalg(eltype(prob.u0)), args...; kwargs...
    )
end

function SciMLBase.__solve(
        prob::NonlinearLeastSquaresProblem, ::Nothing, args...; kwargs...
    )
    return SciMLBase.__solve(
        prob, FastShortcutNLLSPolyalg(eltype(prob.u0)), args...; kwargs...
    )
end

function NonlinearSolveBase.initialization_alg(::NonlinearLeastSquaresProblem, autodiff)
    return FastShortcutNLLSPolyalg(; autodiff)
end

@testitem "Brusselator 2D" tags = [:core] begin
    using LinearAlgebra, SparseArrays, SparseConnectivityTracer, ADTypes,
        SparseMatrixColorings

    const N = 32
    const xyd_brusselator = range(0, stop = 1, length = N)

    brusselator_f(x, y) = (((x - 0.3)^2 + (y - 0.6)^2) <= 0.1^2) * 5.0
    limit(a, N) = a == N + 1 ? 1 : a == 0 ? N : a

    function brusselator_2d_loop(du, u, p)
        A, B, alpha, dx = p
        alpha = alpha / dx^2
        @inbounds for I in CartesianIndices((N, N))
            i, j = Tuple(I)
            x, y = xyd_brusselator[I[1]], xyd_brusselator[I[2]]
            ip1, im1,
                jp1, jm1 = limit(i + 1, N), limit(i - 1, N), limit(j + 1, N),
                limit(j - 1, N)
            du[i, j, 1] = alpha *
                (
                u[im1, j, 1] + u[ip1, j, 1] + u[i, jp1, 1] + u[i, jm1, 1] -
                    4u[i, j, 1]
            ) +
                B +
                u[i, j, 1]^2 * u[i, j, 2] - (A + 1) * u[i, j, 1] +
                brusselator_f(x, y)
            du[i, j, 2] = alpha *
                (
                u[im1, j, 2] + u[ip1, j, 2] + u[i, jp1, 2] + u[i, jm1, 2] -
                    4u[i, j, 2]
            ) + A * u[i, j, 1] - u[i, j, 1]^2 * u[i, j, 2]
        end
    end

    p = (3.4, 1.0, 10.0, step(xyd_brusselator))

    function init_brusselator_2d(xyd)
        N = length(xyd)
        u = zeros(N, N, 2)
        for I in CartesianIndices((N, N))
            x = xyd[I[1]]
            y = xyd[I[2]]
            u[I, 1] = 22 * (y * (1 - y))^(3 / 2)
            u[I, 2] = 27 * (x * (1 - x))^(3 / 2)
        end
        return u
    end

    u0 = init_brusselator_2d(xyd_brusselator)
    prob_brusselator_2d = NonlinearProblem(brusselator_2d_loop, u0, p)
    sol = solve(prob_brusselator_2d, NewtonRaphson(); abstol = 1.0e-8)
    @test norm(sol.resid, Inf) < 1.0e-8

    prob_brusselator_2d_sparse = NonlinearProblem(
        NonlinearFunction(brusselator_2d_loop; sparsity = TracerSparsityDetector()),
        u0, p
    )
    sol = solve(prob_brusselator_2d_sparse, NewtonRaphson(); abstol = 1.0e-8)
    @test norm(sol.resid, Inf) < 1.0e-8

    f! = (du, u) -> brusselator_2d_loop(du, u, p)
    du0 = similar(u0)
    jac_prototype = ADTypes.jacobian_sparsity(f!, du0, u0, TracerSparsityDetector())

    ff_iip = NonlinearFunction(brusselator_2d_loop; jac_prototype)
    prob_brusselator_2d = NonlinearProblem(ff_iip, u0, p)

    sol = solve(prob_brusselator_2d, NewtonRaphson(); abstol = 1.0e-8)
    @test norm(sol.resid, Inf) < 1.0e-8

    sol = solve(
        prob_brusselator_2d,
        NewtonRaphson(autodiff = AutoFiniteDiff()); abstol = 1.0e-8
    )
    @test norm(sol.resid, Inf) < 1.0e-8
end

@testitem "Structured Jacobians" tags = [:core] begin
    using SparseConnectivityTracer, BandedMatrices, LinearAlgebra, SparseArrays,
        SparseMatrixColorings

    N = 16
    p = rand(N)
    u0 = rand(N)

    function f!(du, u, p)
        for i in 2:(length(u) - 1)
            du[i] = u[i - 1] - 2u[i] + u[i + 1] + p[i]
        end
        du[1] = -2u[1] + u[2] + p[1]
        du[end] = u[end - 1] - 2u[end] + p[end]
        return nothing
    end

    function f(u, p)
        du = similar(u, promote_type(eltype(u), eltype(p)))
        f!(du, u, p)
        return du
    end

    for nlf in (f, f!)
        @testset "Dense AD" begin
            nlprob = NonlinearProblem(NonlinearFunction(nlf), u0, p)

            cache = init(nlprob, NewtonRaphson(); abstol = 1.0e-9)
            @test cache.jac_cache.J isa Matrix
            sol = solve!(cache)
            @test SciMLBase.successful_retcode(sol)
        end

        @testset "Unstructured Sparse AD" begin
            nlprob_autosparse = NonlinearProblem(
                NonlinearFunction(nlf; sparsity = TracerSparsityDetector()),
                u0, p
            )

            cache = init(nlprob_autosparse, NewtonRaphson(); abstol = 1.0e-9)
            @test cache.jac_cache.J isa SparseMatrixCSC
            sol = solve!(cache)
            @test SciMLBase.successful_retcode(sol)
        end

        @testset "Structured Sparse AD: Banded Jacobian" begin
            jac_prototype = BandedMatrix(-1 => ones(N - 1), 0 => ones(N), 1 => ones(N - 1))
            nlprob_sparse_structured = NonlinearProblem(
                NonlinearFunction(nlf; jac_prototype), u0, p
            )

            cache = init(nlprob_sparse_structured, NewtonRaphson(); abstol = 1.0e-9)
            @test cache.jac_cache.J isa BandedMatrix
            sol = solve!(cache)
            @test SciMLBase.successful_retcode(sol)
        end

        @testset "Structured Sparse AD: Tridiagonal Jacobian" begin
            jac_prototype = Tridiagonal(ones(N - 1), ones(N), ones(N - 1))
            nlprob_sparse_structured = NonlinearProblem(
                NonlinearFunction(nlf; jac_prototype), u0, p
            )

            cache = init(nlprob_sparse_structured, NewtonRaphson(); abstol = 1.0e-9)
            @test cache.jac_cache.J isa Tridiagonal
            sol = solve!(cache)
            @test SciMLBase.successful_retcode(sol)
        end
    end
end

"""
    EisenstatWalkerForcing2(; η₀ = 0.5, ηₘₐₓ = 0.9, γ = 0.9, α = 2, safeguard = true, safeguard_threshold = 0.1)

Algorithm 2 from the classical work by Eisenstat and Walker (1996) as described by formula (2.6):
    ηₖ = γ * (||rₖ|| / ||rₖ₋₁||)^α

Here the variables denote:
    rₖ residual at iteration k
    η₀   ∈ [0,1) initial value for η
    ηₘₐₓ ∈ [0,1) maximum value for η
    γ    ∈ [0,1) correction factor
    α    ∈ [1,2) correction exponent

Furthermore, the proposed safeguard is implemented:
    ηₖ = max(ηₖ, γ*ηₖ₋₁^α) if γ*ηₖ₋₁^α > safeguard_threshold
to prevent ηₖ from shrinking too fast.
"""
@concrete struct EisenstatWalkerForcing2
    η₀
    ηₘₐₓ
    γ
    α
    safeguard
    safeguard_threshold
end

function EisenstatWalkerForcing2(; η₀ = 0.5, ηₘₐₓ = 0.9, γ = 0.9, α = 2, safeguard = true, safeguard_threshold = 0.1)
    return EisenstatWalkerForcing2(η₀, ηₘₐₓ, γ, α, safeguard, safeguard_threshold)
end


@concrete mutable struct EisenstatWalkerForcing2Cache
    p::EisenstatWalkerForcing2
    η
    rnorm
    rnorm_prev
    internalnorm
    verbosity
end


function pre_step_forcing!(cache::EisenstatWalkerForcing2Cache, descend_cache::NonlinearSolveBase.NewtonDescentCache, J, u, fu, iter)
    @SciMLMessage("Eisenstat-Walker forcing residual norm $(cache.rnorm) with rate estimate $(cache.rnorm / cache.rnorm_prev).", cache.verbosity, :forcing)

    # On the first iteration we initialize η with the default initial value and stop.
    if iter == 0
        cache.η = cache.p.η₀
        @SciMLMessage("Eisenstat-Walker initial iteration to η=$(cache.η).", cache.verbosity, :forcing)
        LinearSolve.update_tolerances!(descend_cache.lincache; reltol = cache.η)
        return nothing
    end

    # Store previous
    ηprev = cache.η

    # Formula (2.6)
    # ||r|| > 0 should be guaranteed by the convergence criterion
    (; rnorm, rnorm_prev) = cache
    (; α, γ) = cache.p
    cache.η = γ * (rnorm / rnorm_prev)^α

    # Safeguard 2 to prevent over-solving
    if cache.p.safeguard
        ηsg = γ * ηprev^α
        if ηsg > cache.p.safeguard_threshold && ηsg > cache.η
            cache.η = ηsg
        end
    end

    # Far away from the root we also need to respect η ∈ [0,1)
    cache.η = clamp(cache.η, 0.0, cache.p.ηₘₐₓ)

    @SciMLMessage("Eisenstat-Walker iter $iter update to η=$(cache.η).", cache.verbosity, :forcing)

    # Communicate new relative tolerance to linear solve
    LinearSolve.update_tolerances!(descend_cache.lincache; reltol = cache.η)

    return nothing
end


function post_step_forcing!(cache::EisenstatWalkerForcing2Cache, J, u, fu, δu, iter)
    # Cache previous residual norm
    cache.rnorm_prev = cache.rnorm
    return cache.rnorm = cache.internalnorm(fu)

    # @SciMLMessage("Eisenstat-Walker sanity check: $(cache.internalnorm(fu + J*δu)) ≤ $(cache.η * cache.internalnorm(fu)).", cache.verbosity, :linear_verbosity)
end


function InternalAPI.init(
        prob::AbstractNonlinearProblem, alg::EisenstatWalkerForcing2, f, fu, u, p,
        args...; verbose, internalnorm::F = L2_NORM, kwargs...
    ) where {F}
    fu_norm = internalnorm(fu)

    return EisenstatWalkerForcing2Cache(
        alg, alg.η₀, fu_norm, fu_norm, internalnorm, verbose
    )
end


function InternalAPI.reinit!(
        cache::EisenstatWalkerForcing2Cache; p = cache.p, kwargs...
    )
    return cache.p = p
end

"""
    TrustRegion(;
        concrete_jac = nothing, linsolve = nothing,
        radius_update_scheme = RadiusUpdateSchemes.Simple, max_trust_radius::Real = 0 // 1,
        initial_trust_radius::Real = 0 // 1, step_threshold::Real = 1 // 10000,
        shrink_threshold::Real = 1 // 4, expand_threshold::Real = 3 // 4,
        shrink_factor::Real = 1 // 4, expand_factor::Real = 2 // 1,
        max_shrink_times::Int = 32,
        vjp_autodiff = nothing, autodiff = nothing, jvp_autodiff = nothing,
    )

An advanced TrustRegion implementation with support for efficient handling of sparse
matrices via colored automatic differentiation and preconditioned linear solvers. Designed
for large-scale and numerically-difficult nonlinear systems.

### Keyword Arguments

  - `radius_update_scheme`: the scheme used to update the trust region radius. Defaults to
    `RadiusUpdateSchemes.Simple`. See [`RadiusUpdateSchemes`](@ref) for more details. For a
    review on trust region radius update schemes, see [yuan2015recent](@citet).

For the remaining arguments, see [`NonlinearSolveFirstOrder.GenericTrustRegionScheme`](@ref)
documentation.
"""
function TrustRegion(;
        concrete_jac = nothing, linsolve = nothing,
        radius_update_scheme = RadiusUpdateSchemes.Simple, max_trust_radius::Real = 0 // 1,
        initial_trust_radius::Real = 0 // 1, step_threshold::Real = 1 // 10000,
        shrink_threshold::Real = 1 // 4, expand_threshold::Real = 3 // 4,
        shrink_factor::Real = 1 // 4, expand_factor::Real = 2 // 1,
        max_shrink_times::Int = 32,
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing,
    )
    descent = Dogleg(; linsolve)
    trustregion = GenericTrustRegionScheme(;
        method = radius_update_scheme, step_threshold, shrink_threshold, expand_threshold,
        shrink_factor, expand_factor, initial_trust_radius, max_trust_radius
    )
    return GeneralizedFirstOrderAlgorithm(;
        trustregion, descent, autodiff, vjp_autodiff, jvp_autodiff, max_shrink_times,
        concrete_jac, name = :TrustRegion
    )
end

# Don't Pollute the namespace
"""
    RadiusUpdateSchemes

`RadiusUpdateSchemes` is provides different types of radius update schemes implemented in
the Trust Region method. These schemes specify how the radius of the so-called trust region
is updated after each iteration of the algorithm. The specific role and caveats associated
with each scheme are provided below.

## Using `RadiusUpdateSchemes`

Simply put the desired scheme as follows:
`sol = solve(prob, alg = TrustRegion(radius_update_scheme = RadiusUpdateSchemes.Hei))`.
"""
module RadiusUpdateSchemes
    # The weird definitions here are needed to main compatibility with the older enum variants

    abstract type AbstractRadiusUpdateScheme end

    function Base.show(io::IO, rus::AbstractRadiusUpdateScheme)
        return print(io, "RadiusUpdateSchemes.$(string(nameof(typeof(rus)))[3:end])")
    end

    const T = AbstractRadiusUpdateScheme

    struct __Simple <: AbstractRadiusUpdateScheme end
    """
        RadiusUpdateSchemes.Simple

    The simple or conventional radius update scheme. This scheme is chosen by default and
    follows the conventional approach to update the trust region radius, i.e. if the trial
    step is accepted it increases the radius by a fixed factor (bounded by a maximum radius)
    and if the trial step is rejected, it shrinks the radius by a fixed factor.
    """
    const Simple = __Simple()

    struct __NLsolve <: AbstractRadiusUpdateScheme end
    """
        RadiusUpdateSchemes.NLsolve

    The same updating scheme as in NLsolve's (https://github.com/JuliaNLSolvers/NLsolve.jl)
    trust region dogleg implementation.
    """
    const NLsolve = __NLsolve()

    struct __NocedalWright <: AbstractRadiusUpdateScheme end
    """
        RadiusUpdateSchemes.NocedalWright

    Trust region updating scheme as in Nocedal and Wright [see Alg 11.5, page 291].
    """
    const NocedalWright = __NocedalWright()

    struct __Hei <: AbstractRadiusUpdateScheme end
    """
        RadiusUpdateSchemes.Hei

    This scheme is proposed in [hei2003self](@citet). The trust region radius depends on the
    size (norm) of the current step size. The hypothesis is to let the radius converge to zero
    as the iterations progress, which is more reliable and robust for ill-conditioned as well
    as degenerate problems.
    """
    const Hei = __Hei()

    struct __Yuan <: AbstractRadiusUpdateScheme end
    """
        RadiusUpdateSchemes.Yuan

    This scheme is proposed by [yuan2015recent](@citet). Similar to Hei's scheme, the
    trust region is updated in a way so that it converges to zero, however here, the radius
    depends on the size (norm) of the current gradient of the objective (merit) function. The
    hypothesis is that the step size is bounded by the gradient size, so it makes sense to let
    the radius depend on the gradient.
    """
    const Yuan = __Yuan()

    struct __Bastin <: AbstractRadiusUpdateScheme end
    """
        RadiusUpdateSchemes.Bastin

    This scheme is proposed by [bastin2010retrospective](@citet). The scheme is called a
    retrospective update scheme as it uses the model function at the current iteration to
    compute the ratio of the actual reduction and the predicted reduction in the previous trial
    step, and use this ratio to update the trust region radius. The hypothesis is to exploit the
    information made available during the optimization process in order to vary the accuracy
    of the objective function computation.
    """
    const Bastin = __Bastin()

    struct __Fan <: AbstractRadiusUpdateScheme end
    """
        RadiusUpdateSchemes.Fan

    This scheme is proposed by [fan2006convergence](@citet). It is very much similar to Hei's
    and Yuan's schemes as it lets the trust region radius depend on the current size (norm) of
    the objective (merit) function itself. These new update schemes are known to improve local
    convergence.
    """
    const Fan = __Fan()

end

const RUS = RadiusUpdateSchemes

"""
    GenericTrustRegionScheme(;
        method = RadiusUpdateSchemes.Simple,
        max_trust_radius = nothing, initial_trust_radius = nothing,
        step_threshold = nothing, shrink_threshold = nothing, expand_threshold = nothing,
        shrink_factor = nothing, expand_factor = nothing
    )

Trust Region Method that updates and stores the current trust region radius in
`trust_region`. For any of the keyword arguments, if the value is `nothing`, then we use
the value used in the respective paper.

### Keyword Arguments

  - `radius_update_scheme`: the choice of radius update scheme to be used. Defaults to
    `RadiusUpdateSchemes.Simple` which follows the conventional approach. Other available
    schemes are documented in [`RadiusUpdateSchemes`](@ref),. These schemes have the trust
    region radius converging to zero that is seen to improve convergence. For more details,
    see [1].
  - `max_trust_radius`: the maximal trust region radius. Defaults to
    `max(norm(fu), maximum(u) - minimum(u))`, except for `RadiusUpdateSchemes.NLsolve`
    where it defaults to `Inf`.
  - `initial_trust_radius`: the initial trust region radius. Defaults to
    `max_trust_radius / 11`, except for `RadiusUpdateSchemes.NLsolve` where it defaults
    to `u0_norm > 0 ? u0_norm : 1`.
  - `step_threshold`: the threshold for taking a step. In every iteration, the threshold is
    compared with a value `r`, which is the actual reduction in the objective function
    divided by the predicted reduction. If `step_threshold > r` the model is not a good
    approximation, and the step is rejected. Defaults to `nothing`.
  - `shrink_threshold`: the threshold for shrinking the trust region radius. In every
    iteration, the threshold is compared with a value `r` which is the actual reduction in
    the objective function divided by the predicted reduction. If `shrink_threshold > r` the
    trust region radius is shrunk by `shrink_factor`. Defaults to `nothing`.
  - `expand_threshold`: the threshold for expanding the trust region radius. If a step is
    taken, i.e `step_threshold < r` (with `r` defined in `shrink_threshold`), a check is
    also made to see if `expand_threshold < r`. If that is true, the trust region radius is
    expanded by `expand_factor`. Defaults to `nothing`.
  - `shrink_factor`: the factor to shrink the trust region radius with if
    `shrink_threshold > r` (with `r` defined in `shrink_threshold`). Defaults to `0.25`.
  - `expand_factor`: the factor to expand the trust region radius with if
    `expand_threshold < r` (with `r` defined in `shrink_threshold`). Defaults to `2.0`.
"""
@kwdef @concrete struct GenericTrustRegionScheme <: AbstractTrustRegionMethod
    method <: RUS.AbstractRadiusUpdateScheme = RUS.Simple
    step_threshold = nothing
    shrink_threshold = nothing
    shrink_factor = nothing
    expand_factor = nothing
    expand_threshold = nothing
    max_trust_radius = nothing
    initial_trust_radius = nothing
end

function InternalAPI.init(
        prob::AbstractNonlinearProblem, alg::GenericTrustRegionScheme, f, fu, u, p,
        args...; stats, internalnorm::F = L2_NORM, vjp_autodiff = nothing,
        jvp_autodiff = nothing, kwargs...
    ) where {F}
    T = promote_type(eltype(u), eltype(fu))
    u0_norm = internalnorm(u)
    fu_norm = internalnorm(fu)

    # Common Setup
    mtr = max_trust_radius(alg.max_trust_radius, T, alg.method, u, fu_norm)
    itr = initial_trust_radius(
        alg.initial_trust_radius, T, alg.method, mtr, u0_norm, fu_norm
    )
    stt = step_threshold(alg.step_threshold, T, alg.method)
    sht = shrink_threshold(alg.shrink_threshold, T, alg.method)
    shf = shrink_factor(alg.shrink_factor, T, alg.method)
    et = expand_threshold(alg.expand_threshold, T, alg.method)
    ef = expand_factor(alg.expand_factor, T, alg.method)

    # Scheme Specific Setup
    p1, p2, p3, p4 = get_parameters(T, alg.method)
    ϵ = T(1.0e-8)

    vjp_operator = alg.method isa RUS.__Yuan || alg.method isa RUS.__Bastin ?
        VecJacOperator(prob, fu, u; autodiff = vjp_autodiff) : nothing

    jvp_operator = alg.method isa RUS.__Bastin ?
        JacVecOperator(prob, fu, u; autodiff = jvp_autodiff) : nothing

    if alg.method isa RUS.__Yuan
        Jᵀfu_cache = StatefulJacobianOperator(vjp_operator, u, prob.p) * Utils.safe_vec(fu)
        itr = T(p1 * internalnorm(Jᵀfu_cache))
    elseif u isa Number
        Jᵀfu_cache = u
    else
        @bb Jᵀfu_cache = similar(u)
    end

    if alg.method isa RUS.__Bastin
        @bb δu_cache = similar(u)
    else
        δu_cache = nothing
    end

    @bb u_cache = similar(u)
    @bb fu_cache = similar(fu)
    @bb Jδu_cache = similar(fu)

    return GenericTrustRegionSchemeCache(
        alg.method, f, p, mtr, itr, itr, stt, sht, et, shf, ef,
        p1, p2, p3, p4, ϵ, T(0), vjp_operator, jvp_operator, Jᵀfu_cache, Jδu_cache,
        δu_cache, internalnorm, u_cache, fu_cache, false, 0, stats, alg
    )
end

@concrete mutable struct GenericTrustRegionSchemeCache <: AbstractTrustRegionMethodCache
    method
    f
    p
    max_trust_radius
    initial_trust_radius
    trust_region
    step_threshold
    shrink_threshold
    expand_threshold
    shrink_factor
    expand_factor
    p1
    p2
    p3
    p4
    ϵ
    ρ
    vjp_operator
    jvp_operator
    Jᵀfu_cache
    Jδu_cache
    δu_cache
    internalnorm
    u_cache
    fu_cache
    last_step_accepted::Bool
    shrink_counter::Int
    stats::NLStats
    alg
end

function InternalAPI.reinit!(
        cache::GenericTrustRegionSchemeCache; p = cache.p, u0 = nothing, kwargs...
    )
    cache.p = p
    if u0 !== nothing
        u0_norm = cache.internalnorm(u0)
    end
    cache.last_step_accepted = false
    cache.trust_region = cache.initial_trust_radius
    return cache.shrink_counter = 0
end

# Defaults
for func in (
        :max_trust_radius, :initial_trust_radius, :step_threshold, :shrink_threshold,
        :shrink_factor, :expand_threshold, :expand_factor,
    )
    @eval function $(func)(val, ::Type{T}, args...) where {T}
        iszero(val) && return $(func)(nothing, T, args...)
        return T(val)
    end
end

max_trust_radius(::Nothing, ::Type{T}, method, u, fu_norm) where {T} = T(Inf)
function max_trust_radius(
        ::Nothing, ::Type{T}, ::Union{RUS.__Simple, RUS.__NocedalWright},
        u, fu_norm
    ) where {T}
    u_min, u_max = extrema(u)
    return max(T(fu_norm), u_max - u_min)
end

function initial_trust_radius(
        ::Nothing, ::Type{T}, method, max_tr, u0_norm, fu_norm
    ) where {T}
    method isa RUS.__NLsolve && return T(ifelse(u0_norm > 0, u0_norm, 1))
    (method isa RUS.__Hei || method isa RUS.__Bastin) && return T(1)
    method isa RUS.__Fan && return T((fu_norm^0.99) / 10)
    return T(max_tr / 11)
end

function step_threshold(::Nothing, ::Type{T}, method) where {T}
    method isa RUS.__Hei && return T(0)
    method isa RUS.__Yuan && return T(1 // 1000)
    method isa RUS.__Bastin && return T(1 // 20)
    return T(1 // 10000)
end

function shrink_threshold(::Nothing, ::Type{T}, method) where {T}
    method isa RUS.__Hei && return T(0)
    (method isa RUS.__NLsolve || method isa RUS.__Bastin) && return T(1 // 20)
    return T(1 // 4)
end

function expand_threshold(::Nothing, ::Type{T}, method) where {T}
    method isa RUS.__NLsolve && return T(9 // 10)
    method isa RUS.__Hei && return T(0)
    method isa RUS.__Bastin && return T(9 // 10)
    return T(3 // 4)
end

function shrink_factor(::Nothing, ::Type{T}, method) where {T}
    method isa RUS.__NLsolve && return T(1 // 2)
    method isa RUS.__Hei && return T(0)
    method isa RUS.__Bastin && return T(1 // 20)
    return T(1 // 4)
end

function get_parameters(::Type{T}, method) where {T}
    method isa RUS.__NLsolve && return (T(1 // 2), T(0), T(0), T(0))
    method isa RUS.__Hei && return (T(5), T(1 // 10), T(15 // 100), T(15 // 100))
    method isa RUS.__Yuan && return (T(2), T(1 // 6), T(6), T(0))
    method isa RUS.__Fan && return (T(1 // 10), T(1 // 4), T(12), T(1.0e18))
    method isa RUS.__Bastin && return (T(5 // 2), T(1 // 4), T(0), T(0))
    return (T(0), T(0), T(0), T(0))
end

expand_factor(::Nothing, ::Type{T}, method) where {T} = T(2)

function rfunc_adaptive_trust_region(
        r::R, c2::R, M::R, γ1::R, γ2::R, β::R
    ) where {R <: Real}
    return ifelse(
        r ≥ c2,
        (2 * (M - 1 - γ2) * atan(r - c2) + (1 + γ2)) / R(π),
        (1 - γ1 - β) * (exp(r - c2) + β / (1 - γ1 - β))
    )
end

function InternalAPI.solve!(
        cache::GenericTrustRegionSchemeCache, J, fu, u, δu, descent_stats
    )
    T = promote_type(eltype(u), eltype(fu))
    @bb @. cache.u_cache = u + δu
    cache.fu_cache = Utils.evaluate_f!!(cache.f, cache.fu_cache, cache.u_cache, cache.p)
    cache.stats.nf += 1

    if hasfield(typeof(descent_stats), :δuJᵀJδu) && !isnan(descent_stats.δuJᵀJδu)
        δuJᵀJδu = descent_stats.δuJᵀJδu
    else
        @bb cache.Jδu_cache = J × vec(δu)
        δuJᵀJδu = Utils.safe_dot(cache.Jδu_cache, cache.Jδu_cache)
    end
    @bb cache.Jᵀfu_cache = transpose(J) × vec(fu)
    num = (cache.internalnorm(cache.fu_cache)^2 - cache.internalnorm(fu)^2) / 2
    denom = Utils.safe_dot(δu, cache.Jᵀfu_cache) + δuJᵀJδu / 2
    cache.ρ = num / denom

    if cache.ρ > cache.step_threshold
        cache.last_step_accepted = true
    else
        cache.last_step_accepted = false
    end

    if cache.method isa RUS.__Simple
        if cache.ρ < cache.shrink_threshold
            cache.trust_region *= cache.shrink_factor
            cache.shrink_counter += 1
        else
            cache.shrink_counter = 0
            if cache.ρ > cache.expand_threshold && cache.ρ > cache.step_threshold
                cache.trust_region = cache.expand_factor * cache.trust_region
            end
        end
    elseif cache.method isa RUS.__NLsolve
        if cache.ρ < cache.shrink_threshold
            cache.trust_region *= cache.shrink_factor
            cache.shrink_counter += 1
        else
            cache.shrink_counter = 0
            if cache.ρ ≥ cache.expand_threshold
                cache.trust_region = cache.expand_factor * cache.internalnorm(δu)
            elseif cache.ρ ≥ cache.p1
                cache.trust_region = max(
                    cache.trust_region, cache.expand_factor * cache.internalnorm(δu)
                )
            end
        end
    elseif cache.method isa RUS.__NocedalWright
        if cache.ρ < cache.shrink_threshold
            cache.trust_region = cache.shrink_factor * cache.internalnorm(δu)
            cache.shrink_counter += 1
        else
            cache.shrink_counter = 0
            if cache.ρ > cache.expand_threshold &&
                    abs(cache.internalnorm(δu) - cache.trust_region) < 1.0e-6 * cache.trust_region
                cache.trust_region = cache.expand_factor * cache.trust_region
            end
        end
    elseif cache.method isa RUS.__Hei
        tr_new = rfunc_adaptive_trust_region(
            cache.ρ, cache.shrink_threshold, cache.p1, cache.p3, cache.p4, cache.p2
        ) * cache.internalnorm(δu)
        if tr_new < cache.trust_region
            cache.shrink_counter += 1
        else
            cache.shrink_counter = 0
        end
        cache.trust_region = tr_new
    elseif cache.method isa RUS.__Yuan
        if cache.ρ < cache.shrink_threshold
            cache.p1 = cache.p2 * cache.p1
            cache.shrink_counter += 1
        else
            if cache.ρ ≥ cache.expand_threshold &&
                    2 * cache.internalnorm(δu) > cache.trust_region
                cache.p1 = cache.p3 * cache.p1
            end
            cache.shrink_counter = 0
        end
        operator = StatefulJacobianOperator(cache.vjp_operator, cache.u_cache, cache.p)
        @bb cache.Jᵀfu_cache = operator × vec(cache.fu_cache)
        cache.trust_region = cache.p1 * cache.internalnorm(cache.Jᵀfu_cache)
    elseif cache.method isa RUS.__Fan
        if cache.ρ < cache.shrink_threshold
            cache.p1 *= cache.p2
            cache.shrink_counter += 1
        else
            cache.shrink_counter = 0
            cache.ρ > cache.expand_threshold &&
                (cache.p1 = min(cache.p1 * cache.p3, cache.p4))
        end
        cache.trust_region = cache.p1 * (cache.internalnorm(cache.fu_cache)^T(0.99))
    elseif cache.method isa RUS.__Bastin
        if cache.ρ > cache.step_threshold
            jvp_op = StatefulJacobianOperator(cache.jvp_operator, cache.u_cache, cache.p)
            vjp_op = StatefulJacobianOperator(cache.vjp_operator, cache.u_cache, cache.p)
            @bb cache.Jδu_cache = jvp_op × vec(cache.δu_cache)
            @bb cache.Jᵀfu_cache = vjp_op × vec(cache.fu_cache)
            denom_1 = dot(Utils.safe_vec(cache.Jᵀfu_cache), cache.Jᵀfu_cache)
            @bb cache.Jᵀfu_cache = vjp_op × vec(cache.Jδu_cache)
            denom_2 = dot(Utils.safe_vec(cache.Jᵀfu_cache), cache.Jᵀfu_cache)
            denom = denom_1 + denom_2 / 2
            ρ = num / denom
            if ρ ≥ cache.expand_threshold
                cache.trust_region = cache.p1 * cache.internalnorm(cache.δu_cache)
            end
            cache.shrink_counter = 0
        else
            cache.trust_region *= cache.p2
            cache.shrink_counter += 1
        end
    end

    cache.trust_region = min(cache.trust_region, cache.max_trust_radius)

    return cache.last_step_accepted, cache.u_cache, cache.fu_cache
end

@testitem "Scalar Jacobians: Issue #451" tags = [:core] begin
    f(u, p) = u^2 - p

    jac_calls = 0
    function df(u, p)
        global jac_calls += 1
        return 2u
    end

    fn = NonlinearFunction(f; jac = df)
    prob = NonlinearProblem(fn, 1.0, 2.0)
    sol = solve(prob, NewtonRaphson())
    @test sol.retcode == ReturnCode.Success
    @test jac_calls ≥ 1

    jac_calls = 0
    fn2 = NonlinearFunction(f)
    prob = NonlinearProblem(fn2, 1.0, 2.0)
    sol = solve(prob, NewtonRaphson())
    @test sol.retcode == ReturnCode.Success
    @test jac_calls == 0
end

@testitem "Dual of BigFloat: Issue #512" tags = [:core] begin
    using NonlinearSolveFirstOrder, ForwardDiff
    fn_iip = NonlinearFunction{true}((du, u, p) -> du .= u .* u .- p)
    u2 = [
        ForwardDiff.Dual(BigFloat(1.0), 5.0), ForwardDiff.Dual(BigFloat(1.0), 5.0),
        ForwardDiff.Dual(BigFloat(1.0), 5.0),
    ]
    prob_iip_bf = NonlinearProblem{true}(fn_iip, u2, ForwardDiff.Dual(BigFloat(2.0), 5.0))
    sol = solve(prob_iip_bf, NewtonRaphson())
    @test sol.retcode == ReturnCode.Success
end

@testitem "TrustRegion reinit! resets trust_region" tags = [:core] begin
    using NonlinearSolveFirstOrder, SciMLBase

    f(u, p) = u .* u .- p
    prob = NonlinearProblem(f, [1.0, 1.0], 2.0)
    cache = init(prob, TrustRegion())

    # Get the trust region cache
    tr_cache = cache.trustregion_cache
    @test tr_cache.trust_region == tr_cache.initial_trust_radius

    # Solve problem to modify the trust region
    sol = solve!(cache)
    @test SciMLBase.successful_retcode(sol)
    @test tr_cache.trust_region != tr_cache.initial_trust_radius

    # Reinitialize and check the trust region was reset
    reinit!(cache, [1.0, 1.0]; p = 2.0)
    @test tr_cache.trust_region == tr_cache.initial_trust_radius
end

"""
    NewtonRaphson(;
        concrete_jac = nothing, linsolve = nothing, linesearch = missing,
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing,
        forcing = nothing,
    )

An advanced NewtonRaphson implementation with support for efficient handling of sparse
matrices via colored automatic differentiation and preconditioned linear solvers. Designed
for large-scale and numerically-difficult nonlinear systems.

### Keyword Arguments

  - `autodiff`: determines the backend used for the Jacobian. Defaults to `nothing` which
    means that a default is selected according to the problem specification.
  - `concrete_jac`: whether to build a concrete Jacobian. If a Krylov-subspace method is
    used, then the Jacobian will not be constructed. Defaults to `nothing`.
  - `linsolve`: the [LinearSolve.jl](https://github.com/SciML/LinearSolve.jl) solver used
    for the linear solves within the Newton method. Defaults to `nothing`, which means it
    uses the LinearSolve.jl default algorithm choice.
  - `linesearch`: the line search algorithm to use. Defaults to `missing` (no line search).
  - `vjp_autodiff`: backend for computing Vector-Jacobian products.
  - `jvp_autodiff`: backend for computing Jacobian-Vector products.
  - `forcing`: Adaptive forcing term strategy for Newton-Krylov methods. When using an
    iterative linear solver (e.g., `KrylovJL_GMRES()`), this controls how accurately the
    linear system is solved at each iteration. Use `EisenstatWalkerForcing2()` for the
    classical Eisenstat-Walker adaptive forcing strategy. Defaults to `nothing` (fixed
    tolerance from the termination condition).
"""
function NewtonRaphson(;
        concrete_jac = nothing, linsolve = nothing, linesearch = missing,
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing,
        forcing = nothing,
    )
    return GeneralizedFirstOrderAlgorithm(;
        linesearch,
        descent = NewtonDescent(; linsolve),
        autodiff, vjp_autodiff, jvp_autodiff,
        concrete_jac,
        forcing,
        name = :NewtonRaphson
    )
end

"""
    LevenbergMarquardt(;
        linsolve = nothing,
        damping_initial::Real = 1.0, α_geodesic::Real = 0.75, disable_geodesic = Val(false),
        damping_increase_factor::Real = 2.0, damping_decrease_factor::Real = 3.0,
        finite_diff_step_geodesic = 0.1, b_uphill::Real = 1.0, min_damping_D::Real = 1e-8,
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing
    )

An advanced Levenberg-Marquardt implementation with the improvements suggested in
[transtrum2012improvements](@citet). Designed for large-scale and numerically-difficult
nonlinear systems.

### Keyword Arguments

  - `damping_initial`: the starting value for the damping factor. The damping factor is
    inversely proportional to the step size. The damping factor is adjusted during each
    iteration. Defaults to `1.0`. See Section 2.1 of [transtrum2012improvements](@citet).
  - `damping_increase_factor`: the factor by which the damping is increased if a step is
    rejected. Defaults to `2.0`. See Section 2.1 of [transtrum2012improvements](@citet).
  - `damping_decrease_factor`: the factor by which the damping is decreased if a step is
    accepted. Defaults to `3.0`. See Section 2.1 of [transtrum2012improvements](@citet).
  - `min_damping_D`: the minimum value of the damping terms in the diagonal damping matrix
    `DᵀD`, where `DᵀD` is given by the largest diagonal entries of `JᵀJ` yet encountered,
    where `J` is the Jacobian. It is suggested by [transtrum2012improvements](@citet) to use
    a minimum value of the elements in `DᵀD` to prevent the damping from being too small.
    Defaults to `1e-8`.
  - `disable_geodesic`: Disables Geodesic Acceleration if set to `Val(true)`. It provides
    a way to trade-off robustness for speed, though in most situations Geodesic Acceleration
    should not be disabled.

For the remaining arguments, see [`GeodesicAcceleration`](@ref) and
[`NonlinearSolveFirstOrder.LevenbergMarquardtTrustRegion`](@ref) documentations.
"""
function LevenbergMarquardt(;
        linsolve = nothing,
        damping_initial::Real = 1.0, α_geodesic::Real = 0.75, disable_geodesic = Val(false),
        damping_increase_factor::Real = 2.0, damping_decrease_factor::Real = 3.0,
        finite_diff_step_geodesic = 0.1, b_uphill::Real = 1.0, min_damping_D::Real = 1.0e-8,
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing
    )
    descent = DampedNewtonDescent(;
        linsolve,
        initial_damping = damping_initial,
        damping_fn = LevenbergMarquardtDampingFunction(
            damping_increase_factor, damping_decrease_factor, min_damping_D
        )
    )
    if disable_geodesic isa Val{false}
        descent = GeodesicAcceleration(descent, finite_diff_step_geodesic, α_geodesic)
    end
    trustregion = LevenbergMarquardtTrustRegion(b_uphill)
    return GeneralizedFirstOrderAlgorithm(;
        trustregion,
        descent,
        autodiff,
        vjp_autodiff,
        jvp_autodiff,
        name = :LevenbergMarquardt,
        concrete_jac = Val(true)
    )
end

@concrete struct LevenbergMarquardtDampingFunction <: AbstractDampingFunction
    increase_factor
    decrease_factor
    min_damping
end

function InternalAPI.init(
        prob::AbstractNonlinearProblem, f::LevenbergMarquardtDampingFunction,
        initial_damping, J, fu, u, normal_form::Val; kwargs...
    )
    T = promote_type(eltype(u), eltype(fu))
    DᵀD = init_levenberg_marquardt_diagonal(u, T(f.min_damping))
    if normal_form isa Val{true}
        J_diag_cache = nothing
    else
        @bb J_diag_cache = similar(u)
    end
    J_damped = T(initial_damping) .* DᵀD
    return LevenbergMarquardtDampingCache(
        T(f.increase_factor), T(f.decrease_factor), T(f.min_damping),
        T(f.increase_factor), T(initial_damping), DᵀD, J_diag_cache, J_damped, f,
        T(initial_damping)
    )
end

@concrete mutable struct LevenbergMarquardtDampingCache <: AbstractDampingFunctionCache
    increase_factor
    decrease_factor
    min_damping
    λ_factor
    λ
    DᵀD
    J_diag_cache
    J_damped
    damping_f
    initial_damping
end

function InternalAPI.reinit!(cache::LevenbergMarquardtDampingCache, args...; kwargs...)
    cache.λ = cache.initial_damping
    cache.λ_factor = cache.damping_f.increase_factor
    if !(cache.DᵀD isa Number)
        if ArrayInterface.can_setindex(cache.DᵀD.diag)
            cache.DᵀD.diag .= cache.min_damping
        else
            cache.DᵀD = Diagonal(ones(typeof(cache.DᵀD.diag)) * cache.min_damping)
        end
    end
    cache.J_damped = cache.λ .* cache.DᵀD
    return
end

function NonlinearSolveBase.requires_normal_form_jacobian(
        ::Union{
            LevenbergMarquardtDampingFunction, LevenbergMarquardtDampingCache,
        }
    )
    return false
end
function NonlinearSolveBase.requires_normal_form_rhs(
        ::Union{
            LevenbergMarquardtDampingFunction, LevenbergMarquardtDampingCache,
        }
    )
    return false
end
function NonlinearSolveBase.returns_norm_form_damping(
        ::Union{
            LevenbergMarquardtDampingFunction, LevenbergMarquardtDampingCache,
        }
    )
    return true
end

(damping::LevenbergMarquardtDampingCache)(::Nothing) = damping.J_damped

function InternalAPI.solve!(
        cache::LevenbergMarquardtDampingCache, J, fu, ::Val{false}; kwargs...
    )
    if cache.J_diag_cache isa Number
        cache.J_diag_cache = abs2(J)
    elseif ArrayInterface.can_setindex(cache.J_diag_cache)
        sum!(abs2, Utils.safe_vec(cache.J_diag_cache), J')
    else
        cache.J_diag_cache = vec(sum(abs2, J; dims = 1))
    end
    cache.DᵀD = update_levenberg_marquardt_diagonal!!(
        cache.DᵀD, Utils.safe_vec(cache.J_diag_cache)
    )
    @bb @. cache.J_damped = cache.λ * cache.DᵀD
    return cache.J_damped
end

function InternalAPI.solve!(
        cache::LevenbergMarquardtDampingCache, JᵀJ, fu, ::Val{true}; kwargs...
    )
    cache.DᵀD = update_levenberg_marquardt_diagonal!!(cache.DᵀD, JᵀJ)
    @bb @. cache.J_damped = cache.λ * cache.DᵀD
    return cache.J_damped
end

function NonlinearSolveBase.callback_into_cache!(
        topcache, cache::LevenbergMarquardtDampingCache, args...
    )
    if NonlinearSolveBase.last_step_accepted(topcache.trustregion_cache) &&
            NonlinearSolveBase.last_step_accepted(topcache.descent_cache)
        cache.λ_factor = 1 / cache.decrease_factor
    end
    cache.λ *= cache.λ_factor
    return cache.λ_factor = cache.increase_factor
end

"""
    LevenbergMarquardtTrustRegion(b_uphill)

Trust Region method for [`LevenbergMarquardt`](@ref). This method is tightly coupled with
the Levenberg-Marquardt method and works by directly updating the damping parameter instead
of specifying a trust region radius.

### Arguments

  - `b_uphill`: a factor that determines if a step is accepted or rejected. The standard
    choice in the Levenberg-Marquardt method is to accept all steps that decrease the cost
    and reject all steps that increase the cost. Although this is a natural and safe choice,
    it is often not the most efficient. Therefore downhill moves are always accepted, but
    uphill moves are only conditionally accepted. To decide whether an uphill move will be
    accepted at each iteration ``i``, we compute
    ``\\beta_i = \\cos(v_{\\text{new}}, v_{\\text{old}})``, which denotes the cosine angle
    between the proposed velocity ``v_{\\text{new}}`` and the velocity of the last accepted
    step ``v_{\\text{old}}``. The idea is to accept uphill moves if the angle is small. To
    specify, uphill moves are accepted if
    ``(1-\\beta_i)^{b_{\\text{uphill}}} C_{i+1} \\le C_i``, where ``C_i`` is the cost at
    iteration ``i``. Reasonable choices for `b_uphill` are `1.0` or `2.0`, with
    `b_uphill = 2.0` allowing higher uphill moves than `b_uphill = 1.0`. When
    `b_uphill = 0.0`, no uphill moves will be accepted. Defaults to `1.0`. See Section 4 of
    [transtrum2012improvements](@citet).
"""
@concrete struct LevenbergMarquardtTrustRegion <: AbstractTrustRegionMethod
    β_uphill
end

function InternalAPI.init(
        prob::AbstractNonlinearProblem, alg::LevenbergMarquardtTrustRegion,
        f::NonlinearFunction, fu, u, p, args...;
        stats, internalnorm::F = L2_NORM, kwargs...
    ) where {F}
    T = promote_type(eltype(u), eltype(fu))
    @bb v = copy(u)
    @bb u_cache = similar(u)
    @bb fu_cache = similar(fu)
    return LevenbergMarquardtTrustRegionCache(
        f, p, T(Inf), v, T(Inf), internalnorm, T(alg.β_uphill), false,
        u_cache, fu_cache, stats
    )
end

@concrete mutable struct LevenbergMarquardtTrustRegionCache <:
    AbstractTrustRegionMethodCache
    f
    p
    loss_old
    v_cache
    norm_v_old
    internalnorm
    β_uphill
    last_step_accepted::Bool
    u_cache
    fu_cache
    stats::NLStats
end

function InternalAPI.reinit!(
        cache::LevenbergMarquardtTrustRegionCache; p = cache.p, u0 = cache.v_cache, kwargs...
    )
    cache.p = p
    @bb copyto!(cache.v_cache, u0)
    cache.loss_old = oftype(cache.loss_old, Inf)
    cache.norm_v_old = oftype(cache.norm_v_old, Inf)
    return cache.last_step_accepted = false
end

function InternalAPI.solve!(
        cache::LevenbergMarquardtTrustRegionCache, J, fu, u, δu, descent_stats
    )
    # This should be true if Geodesic Acceleration is being used
    v = hasfield(typeof(descent_stats), :v) ? descent_stats.v : δu
    norm_v = cache.internalnorm(v)
    β = dot(v, cache.v_cache) / (norm_v * cache.norm_v_old)

    @bb @. cache.u_cache = u + δu
    cache.fu_cache = Utils.evaluate_f!!(cache.f, cache.fu_cache, cache.u_cache, cache.p)
    cache.stats.nf += 1

    loss = cache.internalnorm(cache.fu_cache)

    if (1 - β)^cache.β_uphill * loss ≤ cache.loss_old  # Accept Step
        cache.last_step_accepted = true
        cache.norm_v_old = norm_v
        @bb copyto!(cache.v_cache, v)
    else
        cache.last_step_accepted = false
    end

    return cache.last_step_accepted, cache.u_cache, cache.fu_cache
end

update_levenberg_marquardt_diagonal!!(y::Number, x::Number) = max(y, x)
function update_levenberg_marquardt_diagonal!!(y::Diagonal, x::AbstractVecOrMat)
    if ArrayInterface.can_setindex(y.diag)
        if ArrayInterface.fast_scalar_indexing(y.diag)
            if ndims(x) == 1
                @simd ivdep for i in axes(x, 1)
                    @inbounds y.diag[i] = max(y.diag[i], x[i])
                end
            else
                @simd ivdep for i in axes(x, 1)
                    @inbounds y.diag[i] = max(y.diag[i], x[i, i])
                end
            end
        else
            if ndims(x) == 1
                @. y.diag = max(y.diag, x)
            else
                y.diag .= max.(y.diag, @view(x[diagind(x)]))
            end
        end
        return y
    end
    ndims(x) == 1 && return Diagonal(max.(y.diag, x))
    return Diagonal(max.(y.diag, @view(x[diagind(x)])))
end

init_levenberg_marquardt_diagonal(u::Number, v) = oftype(u, v)
init_levenberg_marquardt_diagonal(u::SArray, v) = Diagonal(ones(typeof(vec(u))) * v)
function init_levenberg_marquardt_diagonal(u, v)
    d = similar(vec(u))
    d .= v
    return Diagonal(d)
end

module NonlinearSolveFirstOrder

using ConcreteStructs: @concrete
using PrecompileTools: @compile_workload, @setup_workload
using Reexport: @reexport
using Setfield: @set!

using ADTypes: ADTypes
using ArrayInterface: ArrayInterface
using LinearAlgebra: LinearAlgebra, Diagonal, dot, diagind
using LineSearch: BackTracking
using StaticArraysCore: SArray

using CommonSolve: CommonSolve
using LinearSolve: LinearSolve  # Trigger Linear Solve extension in NonlinearSolveBase
using MaybeInplace: @bb
using NonlinearSolveBase: NonlinearSolveBase, AbstractNonlinearSolveAlgorithm,
    AbstractNonlinearSolveCache, AbstractDampingFunction,
    AbstractDampingFunctionCache, AbstractTrustRegionMethod,
    AbstractTrustRegionMethodCache,
    Utils, InternalAPI, get_timer_output, @static_timeit,
    update_trace!, L2_NORM, NonlinearSolvePolyAlgorithm,
    NewtonDescent, DampedNewtonDescent, GeodesicAcceleration,
    Dogleg, NonlinearSolveForwardDiffCache, NonlinearVerbosity,
    @SciMLMessage, None, reused_jacobian, AbstractVerbosityPreset
using SciMLBase: SciMLBase, AbstractNonlinearProblem, NLStats, ReturnCode,
    NonlinearFunction,
    NonlinearLeastSquaresProblem, NonlinearProblem, NoSpecialize
using SciMLJacobianOperators: VecJacOperator, JacVecOperator, StatefulJacobianOperator

using FiniteDiff: FiniteDiff    # Default Finite Difference Method
using ForwardDiff: ForwardDiff, Dual  # Default Forward Mode AD

include("solve.jl")
include("raphson.jl")
include("eisenstat_walker.jl")
include("gauss_newton.jl")
include("levenberg_marquardt.jl")
include("trust_region.jl")
include("pseudo_transient.jl")
include("poly_algs.jl")
include("forward_diff.jl")

@setup_workload begin
    nonlinear_functions = (
        (NonlinearFunction{false, NoSpecialize}((u, p) -> u .* u .- p), 0.1),
        (NonlinearFunction{false, NoSpecialize}((u, p) -> u .* u .- p), [0.1]),
        (NonlinearFunction{true, NoSpecialize}((du, u, p) -> du .= u .* u .- p), [0.1]),
    )

    nonlinear_problems = NonlinearProblem[]
    for (fn, u0) in nonlinear_functions
        push!(nonlinear_problems, NonlinearProblem(fn, u0, 2.0))
    end

    nonlinear_functions = (
        (NonlinearFunction{false, NoSpecialize}((u, p) -> (u .^ 2 .- p)[1:1]), [0.1, 0.0]),
        (
            NonlinearFunction{false, NoSpecialize}(
                (
                    u, p,
                ) -> vcat(u .* u .- p, u .* u .- p)
            ),
            [0.1, 0.1],
        ),
        (
            NonlinearFunction{true, NoSpecialize}(
                (du, u, p) -> du[1] = u[1] * u[1] - p, resid_prototype = zeros(1)
            ),
            [0.1, 0.0],
        ),
        (
            NonlinearFunction{true, NoSpecialize}(
                (du, u, p) -> du .= vcat(u .* u .- p, u .* u .- p), resid_prototype = zeros(4)
            ),
            [0.1, 0.1],
        ),
    )

    nlls_problems = NonlinearLeastSquaresProblem[]
    for (fn, u0) in nonlinear_functions
        push!(nlls_problems, NonlinearLeastSquaresProblem(fn, u0, 2.0))
    end

    nlp_algs = [NewtonRaphson(), TrustRegion(), LevenbergMarquardt()]
    nlls_algs = [GaussNewton(), TrustRegion(), LevenbergMarquardt()]

    @compile_workload begin
        @sync begin
            for prob in nonlinear_problems, alg in nlp_algs

                Threads.@spawn CommonSolve.solve(prob, alg; abstol = 1.0e-2, verbose = false)
            end

            for prob in nlls_problems, alg in nlls_algs

                Threads.@spawn CommonSolve.solve(prob, alg; abstol = 1.0e-2, verbose = false)
            end
        end
    end
end

@reexport using SciMLBase, NonlinearSolveBase

export NewtonRaphson, PseudoTransient
export GaussNewton, LevenbergMarquardt, TrustRegion

export EisenstatWalkerForcing2

export RadiusUpdateSchemes

export GeneralizedFirstOrderAlgorithm

# Polyalgorithms
export RobustMultiNewton, FastShortcutNLLSPolyalg

end

@testitem "Aqua" tags = [:core] begin
    using Aqua, NonlinearSolveFirstOrder

    Aqua.test_all(
        NonlinearSolveFirstOrder;
        piracies = false, ambiguities = false
    )
    Aqua.test_piracies(NonlinearSolveFirstOrder; treat_as_own = [NonlinearLeastSquaresProblem])
    Aqua.test_ambiguities(NonlinearSolveFirstOrder; recursive = false)
end

@testitem "Explicit Imports" tags = [:core] begin
    using ExplicitImports, NonlinearSolveFirstOrder

    @test check_no_implicit_imports(
        NonlinearSolveFirstOrder; skip = (Base, Core, SciMLBase)
    ) === nothing
    @test check_no_stale_explicit_imports(NonlinearSolveFirstOrder) === nothing
    @test check_all_qualified_accesses_via_owners(NonlinearSolveFirstOrder) === nothing
end

"""
    GaussNewton(;
        concrete_jac = nothing, linsolve = nothing, linesearch = missing,
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing
    )

An advanced GaussNewton implementation with support for efficient handling of sparse
matrices via colored automatic differentiation and preconditioned linear solvers. Designed
for large-scale and numerically-difficult nonlinear systems.
"""
function GaussNewton(;
        concrete_jac = nothing, linsolve = nothing, linesearch = missing,
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing
    )
    return GeneralizedFirstOrderAlgorithm(;
        linesearch,
        descent = NewtonDescent(; linsolve),
        autodiff, vjp_autodiff, jvp_autodiff,
        concrete_jac,
        name = :GaussNewton
    )
end

"""
    PseudoTransient(;
        concrete_jac = nothing, linesearch = missing, alpha_initial = 1e-3,
        linsolve = nothing,
        autodiff = nothing, jvp_autodiff = nothing, vjp_autodiff = nothing
    )

An implementation of PseudoTransient Method [coffey2003pseudotransient](@cite) that is used
to solve steady state problems in an accelerated manner. It uses an adaptive time-stepping
to integrate an initial value of nonlinear problem until sufficient accuracy in the desired
steady-state is achieved to switch over to Newton's method and gain a rapid convergence.
This implementation specifically uses "switched evolution relaxation"
[kelley1998convergence](@cite) SER method.

### Keyword Arguments

  - `alpha_initial` : the initial pseudo time step. It defaults to `1e-3`. If it is small,
    you are going to need more iterations to converge but it can be more stable.
"""
function PseudoTransient(;
        concrete_jac = nothing, linesearch = missing, alpha_initial = 1.0e-3,
        linsolve = nothing,
        autodiff = nothing, jvp_autodiff = nothing, vjp_autodiff = nothing
    )
    return GeneralizedFirstOrderAlgorithm(;
        linesearch,
        descent = DampedNewtonDescent(;
            linsolve, initial_damping = alpha_initial,
            damping_fn = SwitchedEvolutionRelaxation()
        ),
        autodiff,
        jvp_autodiff,
        vjp_autodiff,
        concrete_jac,
        name = :PseudoTransient
    )
end

"""
    SwitchedEvolutionRelaxation()

Method for updating the damping parameter in the [`PseudoTransient`](@ref) method based on
"switched evolution relaxation" [kelley1998convergence](@cite) SER method.
"""
struct SwitchedEvolutionRelaxation <: AbstractDampingFunction end

"""
    SwitchedEvolutionRelaxationCache <: AbstractDampingFunctionCache

Cache for the [`SwitchedEvolutionRelaxation`](@ref) method.
"""
@concrete mutable struct SwitchedEvolutionRelaxationCache <: AbstractDampingFunctionCache
    res_norm
    α⁻¹
    internalnorm
end

function NonlinearSolveBase.requires_normal_form_jacobian(
        ::Union{
            SwitchedEvolutionRelaxation, SwitchedEvolutionRelaxationCache,
        }
    )
    return false
end

function NonlinearSolveBase.requires_normal_form_rhs(
        ::Union{
            SwitchedEvolutionRelaxation, SwitchedEvolutionRelaxationCache,
        }
    )
    return false
end

function InternalAPI.init(
        prob::AbstractNonlinearProblem, f::SwitchedEvolutionRelaxation,
        initial_damping, J, fu, u, args...;
        internalnorm::F = L2_NORM, kwargs...
    ) where {F}
    T = promote_type(eltype(u), eltype(fu))
    return SwitchedEvolutionRelaxationCache(
        internalnorm(fu), T(inv(initial_damping)), internalnorm
    )
end

(damping::SwitchedEvolutionRelaxationCache)(::Nothing) = damping.α⁻¹

function InternalAPI.solve!(
        damping::SwitchedEvolutionRelaxationCache, J, fu, args...; kwargs...
    )
    res_norm = damping.internalnorm(fu)
    damping.α⁻¹ *= res_norm / damping.res_norm
    damping.res_norm = res_norm
    return damping.α⁻¹
end

"""
    RobustMultiNewton(
        ::Type{T} = Float64;
        concrete_jac = nothing,
        linsolve = nothing,
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing
    )

A polyalgorithm focused on robustness. It uses a mixture of Newton methods with different
globalizing techniques (trust region updates, line searches, etc.) in order to find a
method that is able to adequately solve the minimization problem.

Basically, if this algorithm fails, then "most" good ways of solving your problem fail and
you may need to think about reformulating the model (either there is an issue with the model,
or more precision / more stable linear solver choice is required).

### Arguments

  - `T`: The eltype of the initial guess. It is only used to check if some of the algorithms
    are compatible with the problem type. Defaults to `Float64`.
"""
function RobustMultiNewton(
        ::Type{T} = Float64;
        concrete_jac = nothing,
        linsolve = nothing,
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing
    ) where {T}
    common_kwargs = (; concrete_jac, linsolve, autodiff, vjp_autodiff, jvp_autodiff)
    if T <: Complex # Let's atleast have something here for complex numbers
        algs = (
            NewtonRaphson(; common_kwargs...),
        )
    else
        algs = (
            TrustRegion(; common_kwargs...),
            TrustRegion(; common_kwargs..., radius_update_scheme = RUS.Bastin),
            NewtonRaphson(; common_kwargs...),
            NewtonRaphson(; common_kwargs..., linesearch = BackTracking()),
            TrustRegion(; common_kwargs..., radius_update_scheme = RUS.NLsolve),
            TrustRegion(; common_kwargs..., radius_update_scheme = RUS.Fan),
        )
    end
    return NonlinearSolvePolyAlgorithm(algs)
end

"""
    FastShortcutNLLSPolyalg(
        ::Type{T} = Float64;
        concrete_jac = nothing,
        linsolve = nothing,
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing
    )

A polyalgorithm focused on balancing speed and robustness. It first tries less robust methods
for more performance and then tries more robust techniques if the faster ones fail.

### Arguments

  - `T`: The eltype of the initial guess. It is only used to check if some of the algorithms
    are compatible with the problem type. Defaults to `Float64`.
"""
function FastShortcutNLLSPolyalg(
        ::Type{T} = Float64;
        concrete_jac = nothing,
        linsolve = nothing,
        autodiff = nothing, vjp_autodiff = nothing, jvp_autodiff = nothing
    ) where {T}
    common_kwargs = (; linsolve, autodiff, vjp_autodiff, jvp_autodiff)
    if T <: Complex
        algs = (
            GaussNewton(; common_kwargs..., concrete_jac),
            LevenbergMarquardt(; common_kwargs..., disable_geodesic = Val(true)),
            LevenbergMarquardt(; common_kwargs...),
        )
    else
        algs = (
            GaussNewton(; common_kwargs..., concrete_jac),
            LevenbergMarquardt(; common_kwargs..., disable_geodesic = Val(true)),
            TrustRegion(; common_kwargs..., concrete_jac),
            GaussNewton(; common_kwargs..., linesearch = BackTracking(), concrete_jac),
            TrustRegion(;
                common_kwargs..., radius_update_scheme = RUS.Bastin, concrete_jac
            ),
            LevenbergMarquardt(; common_kwargs...),
        )
    end
    return NonlinearSolvePolyAlgorithm(algs)
end
